/*	$OpenBSD: flex.skl,v 1.6 2001/01/05 18:26:23 millert Exp $	*/

/* A lexical scanner generated by flex */

/* Scanner skeleton version:
 * $Header: /cvs/src/usr.bin/lex/flex.skl,v 1.6 2001/01/05 18:26:23 millert Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>
#include <errno.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>
#include <unistd.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#ifdef __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)


#define YY_USES_REJECT
typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yyleng = (int) (yy_cp - yy_bp); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 49
#define YY_END_OF_BUFFER 50
static yyconst short int yy_acclist[316] =
    {   0,
       50,   48,   49,    3,   48,   49,    2,    4,   49,   35,
       48,   49,   10,   48,   49,   48,   49,   48,   49,   34,
       48,   49,   48,   49,   48,   49,   47,   48,   49,   48,
       49,   48,   49,   48,   49,   45,   48,   49,16428,   45,
       48,   49,16428,   45,   48,   49,16428,   45,   48,   49,
    16428,   25,   48,   49,   33,   48,   49,    6,   49,    7,
       49,    6,   49,   24,   49,   12,   49,   11,   49,   49,
       48,   49,    3,   48,   49,    4,   49,   35,   48,   49,
       10,   48,   49,   48,   49,   48,   49,   34,   48,   49,
       48,   49,   48,   49,   47,   48,   49,   48,   49,   48,

       49,   48,   49,   45,   48,   49,16428,   45,   48,   49,
    16428,   45,   48,   49,16428,   45,   48,   49,16428,   45,
       48,   49,16428,   45,   48,   49,16428,   45,   48,   49,
    16428,   45,   48,   49,16428,   27,   45,   48,   49,16428,
       28,   45,   48,   49,16428,   25,   48,   49,   26,   48,
       49,   33,   48,   49,   45,   48,   49,16428,   45,   48,
       49,16428,   45,   48,   49,16428,   45,   48,   49,16428,
        2,    4,    4,   31,    2,    9,   34,   46,    5,   47,
       29,   32,   30,   45,16428, 8236,   45,16428,   45,16428,
       33,   45,16428,   33,    8,   24,   23,   13,   15,   23,

       15,   23,   16,   23,   17,   23,   18,   23,   19,   23,
       20,   23,   21,   23,   22,   23,   23,   31,    9,   34,
       46,    5,   47,   29,   32,   30,   45,16428, 8236,   45,
    16428,   45,16428,   45,16428,   45,16428,   33,   45,16428,
       45,16428,   45,16428,   33,   45,16428,   45,16428,   45,
    16428,   45,16428,    4,    1,    2,   46,   34,   45,16428,
       35,   45,16428,   13,   15,   15,   14,    1,   46,   34,
       45,16428,   42, 8236,   40, 8236,   35,   45,16428,   38,
     8236,   45,16428,   43, 8236,   41, 8236,   39, 8236,   45,
    16428,    4,    4,    4,    1,    2,    9, 8236,   13,   15,

       14,    1,    9, 8236,   45,16428,   45,16428,    4,   36,
     8236,   37, 8236, 8236, 8236
    } ;

static yyconst short int yy_accept[230] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    7,   10,   13,   16,   18,   20,   23,
       25,   27,   30,   32,   34,   36,   40,   44,   48,   52,
       55,   58,   60,   62,   64,   66,   68,   70,   71,   73,
       76,   78,   81,   84,   86,   88,   91,   93,   95,   98,
      100,  102,  104,  108,  112,  116,  120,  124,  128,  132,
      136,  141,  146,  149,  152,  155,  159,  163,  167,  171,
      171,  172,  172,  173,  174,  175,  175,  177,  177,  177,
      178,  179,  180,  180,  181,  181,  182,  183,  184,  184,
      184,  186,  187,  189,  191,  194,  195,  196,  197,  198,

      201,  203,  205,  207,  209,  211,  213,  215,  217,  218,
      218,  218,  219,  219,  220,  220,  220,  221,  222,  223,
      223,  224,  224,  225,  226,  227,  227,  227,  229,  230,
      232,  234,  236,  238,  241,  243,  245,  246,  248,  250,
      252,  254,  255,  255,  255,  257,  257,  257,  257,  258,
      258,  258,  258,  261,  264,  266,  267,  268,  268,  268,
      269,  269,  269,  269,  270,  270,  270,  270,  273,  273,
      275,  275,  277,  280,  280,  282,  284,  284,  286,  286,
      288,  288,  290,  292,  293,  294,  295,  295,  298,  298,
      298,  298,  298,  298,  299,  301,  302,  302,  304,  304,

      304,  304,  304,  304,  305,  307,  309,  310,  310,  310,
      310,  310,  310,  310,  310,  310,  310,  310,  310,  312,
      312,  314,  314,  314,  315,  315,  315,  316,  316
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    5,    6,    7,    1,    8,    5,    9,
       10,   11,   12,    1,   12,   13,   14,   15,   15,   15,
       15,   15,   15,   15,   15,   16,   16,    1,    1,   17,
       18,   19,    1,    1,   20,   21,   21,   22,   23,   24,
       25,   26,   27,   26,   28,   26,   26,   29,   30,   31,
       26,   32,   33,   34,   26,   26,   26,   35,   36,   26,
       37,   38,   39,    1,   40,    1,   41,   42,   21,   22,

       21,   43,   25,   26,   27,   26,   28,   26,   26,   44,
       30,   31,   26,   45,   33,   46,   26,   47,   26,   48,
       36,   26,    1,   49,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[50] =
    {   0,
        1,    1,    2,    1,    3,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    4,    4,    1,    1,    1,    4,
        4,    4,    4,    4,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    3,    1,    1,
        4,    4,    4,    1,    1,    1,    1,    1,    1
    } ;

static yyconst short int yy_base[249] =
    {   0,
        0,    0,   47,   48,   49,   50,   88,    0,  114,    0,
     1071,   53,   54, 1062,   59,   60,   61,  162,   62,   68,
       69,  209,  137,  210,  211,  232,  114,  253,  116,   71,
      281, 1801, 1801,  999,    0, 1801, 1801,  316,  844,  831,
      819,  134,  790,   78,  364,  212,  278,   75,  283,  208,
      282,  284,  413,  257,  274,  275,  280,  282,  284,  292,
      293,  294,  776,  666,  280,  306,  311,  312,  305,  309,
     1801,    0,  663,  462,  339,  340, 1801,  511,  560,  345,
      607,  608,  609,  624,  626,  610,  625,  641,  643,  646,
      590,  651,  633,  630,  591,  660, 1801,    0, 1801,  215,

      338, 1801, 1801, 1801, 1801, 1801, 1801, 1801,    0,  636,
        0,  619,  662, 1801,  677,  726,  611,  769,  458,  771,
      775,  787,  409,  360,  344,  798,  661,  592,  318,  767,
      775,  777,  779,  628,  799,  783,  308,  812,  813,  816,
      793,  860,  909,  826, 1801,  958,    0,  832,  837, 1005,
     1015, 1063,  631,  780,  765,  834,    0, 1081,  829, 1801,
     1130,    0,  839, 1060, 1004, 1179, 1227, 1202, 1231,  298,
     1234,  288, 1206, 1246,  285, 1213, 1249,  216, 1252,  214,
     1264,  147, 1231, 1071, 1282,    0, 1262, 1801, 1331,    0,
        0, 1380, 1428, 1269,  843, 1801, 1274, 1801, 1446,    0,

        0, 1495, 1543, 1427, 1544, 1545,    0,    0, 1549, 1589,
     1562,    0,    0, 1572, 1638, 1686,    0, 1569,  144, 1688,
      135,    0, 1698, 1704,    0, 1710, 1716, 1801, 1728, 1732,
     1736, 1740, 1744, 1748, 1752, 1756, 1760, 1764,   75, 1768,
     1772,   69, 1776, 1780, 1784, 1788, 1792, 1796
    } ;

static yyconst short int yy_def[249] =
    {   0,
      228,    1,  229,  229,  230,  230,  228,    7,    7,    9,
      228,  231,  231,  232,  231,  231,  233,  228,  231,  231,
      231,  231,  231,  231,  231,  228,   26,   26,   26,  231,
      231,  228,  228,  228,  234,  228,  228,  235,  236,  236,
      232,  236,  236,  237,  228,  236,  236,  236,  236,  236,
      236,  236,  228,   53,   53,   53,   53,   53,   53,   53,
       53,   53,  236,  236,  236,   53,   53,   53,   53,  231,
      228,   18,  232,  228,  231,  233,  228,  228,  228,  231,
      231,  231,  231,  231,  231,  231,  231,  231,  231,  238,
       26,  231,   26,   26,   26,  231,  228,  234,  228,  228,

      228,  228,  228,  228,  228,  228,  228,  228,  239,  236,
       45,  236,  237,  228,  228,  228,  236,  236,  236,  236,
      236,  236,  236,  236,  236,  236,  240,   53,  236,   53,
       53,   53,   53,   53,   53,   53,  236,   53,   53,   53,
       53,  228,  228,  241,  228,  228,   79,  231,  231,  238,
      228,  238,   26,   26,  228,  228,  242,  228,  243,  228,
      228,  116,  236,  236,  240,  228,  240,   53,  236,  236,
      236,  236,   53,  236,  236,   53,  236,  236,  236,  236,
      236,  236,   53,  244,  228,  142,  245,  228,  228,  143,
       79,  228,  238,  238,  228,  228,  246,  228,  228,  158,

      116,  228,  240,  240,   53,   53,  142,  143,  247,  228,
      247,  192,  158,  248,  228,  248,  202,  236,  236,  236,
      236,  192,  247,  247,  202,  248,  248,    0,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228
    } ;

static yyconst short int yy_nxt[1851] =
    {   0,
       12,   13,   14,   15,   16,   17,   18,   19,   12,   12,
       12,   12,   20,   21,   22,   22,   23,   24,   25,   26,
       27,   27,   27,   27,   27,   27,   27,   27,   28,   29,
       27,   27,   27,   27,   27,   27,   30,   12,   12,   12,
       26,   27,   27,   28,   27,   27,   27,   27,   31,   33,
       33,   36,   36,   37,   37,   71,   71,   34,   34,   72,
       72,   71,   71,   77,   71,   72,   72,   78,   72,   80,
       71,   71,  196,   71,   72,   72,   75,   72,  157,   82,
      114,  111,   81,   81,  115,  119,   38,   38,   39,   40,
       41,   42,   43,   44,   45,   46,   39,   39,   39,   39,

       47,   48,   49,   49,   50,   51,   52,   53,   54,   54,
       54,   55,   56,   54,   54,   54,   57,   58,   54,   59,
       60,   54,   61,   62,   63,   39,   64,   39,   53,   54,
       55,   57,   59,   54,   54,   61,   65,   66,   67,   71,
      111,  111,   91,   72,   91,   68,   69,   95,   54,   54,
      111,  112,   39,  111,   86,   75,   66,   91,   68,   91,
       95,   54,   70,   70,   71,   70,   70,   70,   72,   70,
       70,   70,   70,   70,   70,   70,   70,   70,   70,   70,
       70,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   70,   70,

       70,   70,   79,   79,   79,   79,   79,   79,   79,   79,
       70,   71,   71,   71,  111,   72,   72,   72,  111,  117,
      111,   83,  111,   84,   84,  123,  112,   87,   88,  155,
      156,   85,   70,   89,   71,   70,   70,   70,   72,   70,
       90,   70,   70,   70,   70,   70,   91,   91,   70,   92,
       70,   91,   91,   91,   91,   91,   91,   91,   91,   91,
       93,   91,   91,   91,   91,   91,   91,   91,   70,   70,
       70,   91,   91,   91,   91,   93,   91,   91,   91,   91,
       70,   91,   94,   71,  111,  128,  111,   72,  111,  111,
      111,  111,  118,  118,  111,  120,   91,  121,  121,  124,

      128,  125,  128,  128,  111,  122,  131,  132,  128,  133,
      128,   71,  128,  134,  111,   72,  135,  128,  128,  136,
      128,  128,  128,  128,  111,  128,  134,  128,  137,   96,
      100,  101,  141,  128,  128,  128,  128,  128,  138,  128,
      128,   71,   77,  139,  140,   72,   78,   71,  128,  128,
      111,   72,  156,  156,  128,  128,  102,  103,  104,  105,
      106,  107,  108,  109,  110,  110,  111,  110,  110,  110,
      111,  110,  110,  110,  110,  110,  110,  110,  110,  110,
      110,  110,  110,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,

      110,  110,  110,  110,  116,  116,  116,  116,  116,  116,
      116,  116,  110,  110,  126,  111,  110,  110,  110,  111,
      110,  127,  110,  110,  110,  110,  110,  128,  128,  110,
      129,  110,  128,  128,  128,  128,  128,  128,  128,  128,
      128,  130,  128,  128,  128,  128,  128,  128,  128,  110,
      110,  110,  128,  128,  128,  128,  130,  128,  128,  128,
      128,  110,   73,   73,  111,   73,   73,   73,   74,   73,
       73,   73,   73,   73,   73,   73,   73,   73,   73,   73,
       73,  142,  142,  142,  142,  142,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,   73,   73,

       73,   73,  142,  142,  142,  142,  142,  142,  142,  142,
       73,   76,   76,   77,   76,   76,   76,   78,   76,   76,
       76,   76,   76,   76,   76,   76,   76,   76,   76,   76,
      143,  143,  143,  143,  143,  143,  143,  143,  143,  143,
      143,  143,  143,  143,  143,  143,  143,   76,   76,   76,
       76,  143,  143,  143,  143,  143,  143,  143,  143,   76,
      144,  144,  145,  144,  144,  144,  146,  144,  144,  144,
      144,  144,  144,  144,  147,  147,  144,  144,  144,  147,
      147,  147,  147,  147,  147,  147,  147,  147,  147,  147,
      147,  147,  147,  147,  147,  147,  144,  144,  144,  147,

      147,  147,  147,  147,  147,  147,  147,  147,  144,   71,
       71,   71,   71,   72,   72,   72,   72,  111,   91,   91,
      128,   81,   81,   81,   81,  111,   71,   71,   71,   85,
       72,   72,   72,   91,   91,  128,   83,  148,   84,   84,
      149,  149,  111,   71,   89,   71,   85,   72,   71,   72,
       70,   90,  151,   71,  153,  152,  128,   72,   91,   91,
       92,   91,   71,  154,  114,  110,   72,  166,  115,   74,
      167,  128,  111,   91,   91,  154,   91,  113,  113,  114,
      113,  113,  113,  115,  113,  113,  113,  113,  113,  113,
      113,  113,  113,  113,  113,  113,  158,  158,  158,  158,

      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  113,  113,  113,  113,  158,  158,  158,
      158,  158,  158,  158,  158,  113,  159,  159,  160,  159,
      159,  159,  161,  159,  159,  159,  159,  159,  159,  159,
      162,  162,  159,  159,  159,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  162,  162,  162,  162,  162,  162,
      162,  162,  159,  159,  159,  162,  162,  162,  162,  162,
      162,  162,  162,  162,  159,  111,  169,  111,  171,  195,
      156,  111,  111,  118,  118,  118,  118,  120,  168,  121,
      121,  122,  170,  111,  172,  128,  111,  122,  163,  126,

      174,  164,  164,  128,  111,  128,  127,  128,   91,  176,
      128,  128,  173,  177,  179,  129,  175,  181,  128,  183,
      128,  128,  128,   91,  173,   74,  128,  128,  145,  178,
      180,  160,  146,  182,   71,  161,  128,  111,   72,   71,
      128,  128,  128,   72,  128,  111,  149,  149,  156,  156,
      111,  149,  149,  164,  164,  128,  128,  156,  156,  128,
      184,  184,  160,  184,  184,  184,  185,  184,  184,  184,
      184,  184,  184,  184,  186,  186,  184,  184,  184,  186,
      186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
      186,  186,  186,  186,  186,  186,  184,  184,  184,  186,

      186,  186,  186,  186,  186,  186,  186,  186,  184,  187,
      187,  188,  187,  187,  187,  189,  187,  187,  187,  187,
      187,  187,  187,  190,  190,  187,  187,  187,  190,  190,
      190,  190,  190,  190,  190,  190,  190,  190,  190,  190,
      190,  190,  190,  190,  190,  187,  187,  187,  190,  190,
      190,  190,  190,  190,  190,  190,  190,  187,  144,  144,
      145,  144,  144,  144,  146,  144,  144,  144,  144,  144,
      144,  144,  144,  144,  144,  144,  144,  191,  191,  191,
      191,  191,  191,  191,  191,  191,  191,  191,  191,  191,
      191,  191,  191,  191,  144,  144,  144,  144,  191,  191,

      191,  191,  191,  191,  191,  191,  144,   71,  110,   70,
      166,  151,   97,  167,  152,  150,  150,   71,  150,   70,
      150,  151,  150,  150,  152,  150,  150,  150,  150,  150,
      150,  150,  150,  150,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  150,  150,  150,  150,  192,  192,  192,  192,  192,
      192,  192,  192,  150,  193,   71,  111,   70,   74,  151,
      228,  228,  152,  160,  164,  164,  228,  185,  228,  228,
      194,  197,  197,  198,  197,  197,  197,  199,  197,  197,
      197,  197,  197,  197,  197,  200,  200,  197,  197,  197,

      200,  200,  200,  200,  200,  200,  200,  200,  200,  200,
      200,  200,  200,  200,  200,  200,  200,  197,  197,  197,
      200,  200,  200,  200,  200,  200,  200,  200,  200,  197,
      159,  159,  160,  159,  159,  159,  161,  159,  159,  159,
      159,  159,  159,  159,  159,  159,  159,  159,  159,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  159,  159,  159,  159,
      201,  201,  201,  201,  201,  201,  201,  201,  159,  165,
      165,  228,  165,  110,  165,  166,  165,  165,  167,  165,
      165,  165,  165,  165,  165,  165,  165,  165,  202,  202,

      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  202,  165,  165,  165,  165,  202,
      202,  202,  202,  202,  202,  202,  202,  165,  203,  228,
      128,  110,  169,  166,  128,  171,  167,  111,  228,  127,
      111,  128,  127,  205,  204,  128,  228,  174,  170,  128,
      177,  172,  111,  179,  127,  111,  128,  127,  111,  128,
      127,  206,  228,  175,  188,  181,  178,  228,  189,  180,
      111,   71,  127,   70,  128,  151,  198,  228,  152,  228,
      199,  182,  184,  184,  160,  184,  184,  184,  185,  184,
      184,  184,  184,  184,  184,  184,  184,  184,  184,  184,

      184,  207,  207,  207,  207,  207,  207,  207,  207,  207,
      207,  207,  207,  207,  207,  207,  207,  207,  184,  184,
      184,  184,  207,  207,  207,  207,  207,  207,  207,  207,
      184,  187,  187,  188,  187,  187,  187,  189,  187,  187,
      187,  187,  187,  187,  187,  187,  187,  187,  187,  187,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  187,  187,  187,
      187,  208,  208,  208,  208,  208,  208,  208,  208,  187,
      209,  209,  145,  209,  144,  209,  210,  209,  209,  211,
      209,  209,  209,  209,  212,  212,  209,  209,  209,  212,

      212,  212,  212,  212,  212,  212,  212,  212,  212,  212,
      212,  212,  212,  212,  212,  212,  209,  209,  209,  212,
      212,  212,  212,  212,  212,  212,  212,  212,  209,  193,
       71,  110,   70,  166,  151,  228,  167,  152,  228,  228,
      228,  228,  228,  228,  228,  194,  197,  197,  198,  197,
      197,  197,  199,  197,  197,  197,  197,  197,  197,  197,
      197,  197,  197,  197,  197,  213,  213,  213,  213,  213,
      213,  213,  213,  213,  213,  213,  213,  213,  213,  213,
      213,  213,  197,  197,  197,  197,  213,  213,  213,  213,
      213,  213,  213,  213,  197,  214,  214,  160,  214,  159,

      214,  215,  214,  214,  216,  214,  214,  214,  214,  217,
      217,  214,  214,  214,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  217,  217,  217,  217,  217,  217,  217,
      217,  214,  214,  214,  217,  217,  217,  217,  217,  217,
      217,  217,  217,  214,  203,  218,  220,  110,  228,  166,
      228,  145,  167,  144,  228,  210,  228,  228,  211,  228,
      204,  219,  221,  223,  145,  228,  144,  228,  210,  228,
      218,  211,  128,  128,  160,  111,  159,  127,  215,  224,
      228,  216,  228,  228,  228,  228,  219,  128,  128,  209,
      209,  145,  209,  144,  209,  210,  209,  209,  211,  209,

      209,  209,  209,  209,  209,  209,  209,  209,  222,  222,
      222,  222,  222,  222,  222,  222,  222,  222,  222,  222,
      222,  222,  222,  222,  222,  209,  209,  209,  209,  222,
      222,  222,  222,  222,  222,  222,  222,  209,  214,  214,
      160,  214,  159,  214,  215,  214,  214,  216,  214,  214,
      214,  214,  214,  214,  214,  214,  214,  225,  225,  225,
      225,  225,  225,  225,  225,  225,  225,  225,  225,  225,
      225,  225,  225,  225,  214,  214,  214,  214,  225,  225,
      225,  225,  225,  225,  225,  225,  214,  226,  160,  220,
      159,  228,  215,  228,  111,  216,  127,  228,  228,  223,

      145,  228,  144,  227,  210,  221,  145,  211,  144,  228,
      210,  226,  160,  211,  159,  224,  215,  228,  160,  216,
      159,  228,  215,  228,  228,  216,  228,  227,   32,   32,
       32,   32,   35,   35,   35,   35,   70,   70,   70,   70,
       73,  228,   73,   73,   76,   76,   76,   76,   98,  228,
      228,   98,   99,   99,   99,   99,  110,  228,  110,  110,
      113,  113,  113,  113,  150,  150,  150,  150,  165,  228,
      165,  165,  144,  144,  144,  144,  159,  159,  159,  159,
      184,  184,  184,  184,  187,  187,  187,  187,  197,  197,
      197,  197,  209,  209,  209,  209,  214,  214,  214,  214,

       11,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228
    } ;

static yyconst short int yy_chk[1851] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    3,
        4,    5,    6,    5,    6,   12,   13,    3,    4,   12,
       13,   15,   16,   17,   19,   15,   16,   17,   19,   19,
       20,   21,  242,   30,   20,   21,   15,   30,  239,   21,
       44,   48,   20,   20,   44,   48,    5,    6,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,

        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    9,    9,   23,
       42,  221,   27,   23,   29,    9,    9,   29,    9,    9,
      219,   42,    9,  182,   23,   23,    9,   27,    9,   29,
       29,    9,   18,   18,   18,   18,   18,   18,   18,   18,
       18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
       18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
       18,   18,   18,   18,   18,   18,   18,   18,   18,   18,

       18,   18,   18,   18,   18,   18,   18,   18,   18,   18,
       18,   22,   24,   25,   50,   22,   24,   25,   46,   46,
      180,   22,  178,   22,   22,   50,   50,   24,   25,  100,
      100,   22,   26,   26,   26,   26,   26,   26,   26,   26,
       26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
       26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
       26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
       26,   26,   26,   26,   26,   26,   26,   26,   26,   26,
       26,   28,   28,   31,   47,   54,   65,   31,   51,   49,
       52,  175,   47,   47,  172,   49,   28,   49,   49,   51,

       54,   52,   55,   56,  170,   49,   55,   56,   57,   57,
       58,   70,   59,   58,  137,   70,   59,   55,   56,   60,
       60,   61,   62,   57,  129,   58,   58,   59,   65,   31,
       38,   38,   69,   69,   66,   60,   61,   62,   66,   67,
       68,   75,   76,   67,   68,   75,   76,   80,   69,   66,
      125,   80,  101,  101,   67,   68,   38,   38,   38,   38,
       38,   38,   38,   38,   45,   45,  124,   45,   45,   45,
       45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
       45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
       45,   45,   45,   45,   45,   45,   45,   45,   45,   45,

       45,   45,   45,   45,   45,   45,   45,   45,   45,   45,
       45,   45,   45,   53,   53,  123,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   53,   53,   53,   53,   53,   53,   53,   53,
       53,   53,   74,   74,  119,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,

       74,   74,   74,   74,   74,   74,   74,   74,   74,   74,
       74,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       78,   78,   78,   78,   78,   78,   78,   78,   78,   78,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,
       79,   79,   79,   79,   79,   79,   79,   79,   79,   79,

       79,   79,   79,   79,   79,   79,   79,   79,   79,   81,
       82,   83,   86,   81,   82,   83,   86,  117,   91,   95,
      128,   81,   81,   83,   83,  112,   84,   87,   85,   81,
       84,   87,   85,   91,   95,  128,   84,   85,   84,   84,
       85,   85,  110,   88,   89,   89,   84,   88,   90,   89,
       90,   89,   90,   92,   93,   90,  134,   92,   94,  153,
       89,   93,   96,   94,  113,  127,   96,  127,  113,   73,
      127,  134,   64,   94,  153,   94,   93,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,

      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  118,  131,  120,  132,  155,
      155,  121,   63,  118,  118,  120,  120,  121,  130,  121,
      121,  118,  131,  122,  132,  130,   43,  121,  122,  126,

      135,  122,  122,  131,  126,  132,  126,  133,  154,  136,
      130,  136,  133,  138,  139,  126,  135,  140,  131,  141,
      132,  141,  133,  154,  133,   41,  136,  135,  144,  138,
      139,  159,  144,  140,  148,  159,  141,   40,  148,  149,
      138,  139,  135,  149,  140,  163,  148,  148,  156,  156,
       39,  149,  149,  163,  163,  138,  139,  195,  195,  140,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,
      142,  142,  142,  142,  142,  142,  142,  142,  142,  142,

      142,  142,  142,  142,  142,  142,  142,  142,  142,  143,
      143,  143,  143,  143,  143,  143,  143,  143,  143,  143,
      143,  143,  143,  143,  143,  143,  143,  143,  143,  143,
      143,  143,  143,  143,  143,  143,  143,  143,  143,  143,
      143,  143,  143,  143,  143,  143,  143,  143,  143,  143,
      143,  143,  143,  143,  143,  143,  143,  143,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,
      146,  146,  146,  146,  146,  146,  146,  146,  146,  146,

      146,  146,  146,  146,  146,  146,  146,  150,  165,  150,
      165,  150,   34,  165,  150,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
      151,  151,  151,  151,  152,  152,  164,  152,   14,  152,
       11,    0,  152,  184,  164,  164,    0,  184,    0,    0,
      152,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,

      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      158,  158,  158,  158,  158,  158,  158,  158,  158,  158,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  161,
      161,  161,  161,  161,  161,  161,  161,  161,  161,  166,
      166,    0,  166,  166,  166,  166,  166,  166,  166,  166,
      166,  166,  166,  166,  166,  166,  166,  166,  166,  166,

      166,  166,  166,  166,  166,  166,  166,  166,  166,  166,
      166,  166,  166,  166,  166,  166,  166,  166,  166,  166,
      166,  166,  166,  166,  166,  166,  166,  166,  167,    0,
      168,  167,  169,  167,  173,  171,  167,  169,    0,  169,
      171,  176,  171,  176,  167,  168,    0,  174,  169,  173,
      177,  171,  174,  179,  174,  177,  176,  177,  179,  183,
      179,  183,    0,  174,  187,  181,  177,    0,  187,  179,
      181,  194,  181,  194,  183,  194,  197,    0,  194,    0,
      197,  181,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,

      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
      185,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      189,  189,  189,  189,  189,  189,  189,  189,  189,  189,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,

      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  192,
      192,  192,  192,  192,  192,  192,  192,  192,  192,  193,
      193,  204,  193,  204,  193,    0,  204,  193,    0,    0,
        0,    0,    0,    0,    0,  193,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  199,  199,  199,  199,  199,
      199,  199,  199,  199,  199,  202,  202,  202,  202,  202,

      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  202,  202,  202,  202,  202,  202,
      202,  202,  202,  202,  203,  205,  206,  203,    0,  203,
        0,  209,  203,  209,    0,  209,    0,    0,  209,    0,
      203,  205,  206,  211,  211,    0,  211,    0,  211,    0,
      218,  211,  205,  206,  214,  218,  214,  218,  214,  211,
        0,  214,    0,    0,    0,    0,  218,  205,  206,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,

      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  215,  215,  215,
      215,  215,  215,  215,  215,  215,  215,  216,  216,  220,
      216,    0,  216,    0,  220,  216,  220,    0,    0,  223,

      223,    0,  223,  216,  223,  220,  224,  223,  224,    0,
      224,  226,  226,  224,  226,  223,  226,    0,  227,  226,
      227,    0,  227,    0,    0,  227,    0,  226,  229,  229,
      229,  229,  230,  230,  230,  230,  231,  231,  231,  231,
      232,    0,  232,  232,  233,  233,  233,  233,  234,    0,
        0,  234,  235,  235,  235,  235,  236,    0,  236,  236,
      237,  237,  237,  237,  238,  238,  238,  238,  240,    0,
      240,  240,  241,  241,  241,  241,  243,  243,  243,  243,
      244,  244,  244,  244,  245,  245,  245,  245,  246,  246,
      246,  246,  247,  247,  247,  247,  248,  248,  248,  248,

      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228,
      228,  228,  228,  228,  228,  228,  228,  228,  228,  228
    } ;

static yy_state_type yy_state_buf[YY_BUF_SIZE + 2], *yy_state_ptr;
static char *yy_full_match;
static int yy_lp;
static int yy_looking_for_trail_begin = 0;
static int yy_full_lp;
static int *yy_full_state;
#define YY_TRAILING_MASK 0x2000
#define YY_TRAILING_HEAD_MASK 0x4000
#define REJECT \
{ \
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */ \
yy_cp = yy_full_match; /* restore poss. backed-over text */ \
yy_lp = yy_full_lp; /* restore orig. accepting pos. */ \
yy_state_ptr = yy_full_state; /* restore orig. state */ \
yy_current_state = *yy_state_ptr; /* restore curr. state */ \
++yy_lp; \
goto find_rule; \
}
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "control_lex.l"
#define INITIAL 0
#line 2 "control_lex.l"
/****************************************************************************
 *                                                                          *
 *     Loki - Programs for genetic analysis of complex traits using MCMC    *
 *                                                                          *
 *             Simon Heath - University of Washington                       *
 *                                                                          *
 *                       March 1997                                         *
 *                                                                          *
 * control_lex.l:                                                           *
 *                                                                          *
 * flex (NOT lex!) source for control file lexer.                           *
 *                                                                          *
 ****************************************************************************/

#include <config.h>
#include <stdlib.h>
#include <string.h>
#ifdef HAVE_UNISTD_H
#include <unistd.h>
#endif
#ifdef USE_DMALLOC
#include <dmalloc.h>
#endif
#include <ctype.h>
#include <sys/stat.h>
	
#include "control_parse.h"
#include "scan.h"
#include "scanner.h"
#include "utils.h"

#define YY_DECL int yy_orig_lex YY_PROTO(( void ))
#define MAX_STRING 512
#define LINEBUFSIZE 4096
#ifndef YY_STACK_USED
#define YY_STACK_USED 0
#endif
#ifndef YY_ALWAYS_INTERACTIVE
#define YY_ALWAYS_INTERACTIVE 0
#endif
#ifndef YY_NEVER_INTERACTIVE
#define YY_NEVER_INTERACTIVE 0
#endif
#ifndef YY_MAIN
#define YY_MAIN 0
#endif
	
int lineno=1,lineno1=1,at_file,at_model,at_use,begin_comm;
char linebuf[LINEBUFSIZE],linebuf1[LINEBUFSIZE];
static char *get_string(char *s,int size);
static YY_BUFFER_STATE bufstate_list[MAX_INCLUDE];
char *fname_list[MAX_INCLUDE+1];
int list_ptr;

static int tokenpos,stringbuf_ptr,ff_flag,ln_list[MAX_INCLUDE],ln1_list[MAX_INCLUDE];
static char stringbuf[MAX_STRING];
static void process_env_var(char *ptr);
static void append_to_sbuf(int *sptr,char c);

#define COMMENT 1

#define STR 2
 
#define ATFORMAT 3

#define ISTATE 4

#line 970 "lex.yy.c"

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#ifdef __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;

#line 68 "control_lex.l"



	int token;


#line 1128 "lex.yy.c"

	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
		yy_state_ptr = yy_state_buf;
		*yy_state_ptr++ = yy_current_state;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 229 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			*yy_state_ptr++ = yy_current_state;
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 1801 );

yy_find_action:
		yy_current_state = *--yy_state_ptr;
		yy_lp = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( yy_lp && yy_lp < yy_accept[yy_current_state + 1] )
				{
				yy_act = yy_acclist[yy_lp];
				if ( yy_act & YY_TRAILING_HEAD_MASK ||
				     yy_looking_for_trail_begin )
					{
					if ( yy_act == yy_looking_for_trail_begin )
						{
						yy_looking_for_trail_begin = 0;
						yy_act &= ~YY_TRAILING_HEAD_MASK;
						break;
						}
					}
				else if ( yy_act & YY_TRAILING_MASK )
					{
					yy_looking_for_trail_begin = yy_act & ~YY_TRAILING_MASK;
					yy_looking_for_trail_begin |= YY_TRAILING_HEAD_MASK;
					}
				else
					{
					yy_full_match = yy_cp;
					yy_full_state = yy_state_ptr;
					yy_full_lp = yy_lp;
					break;
					}
				++yy_lp;
				goto find_rule;
				}
			--yy_cp;
			yy_current_state = *--yy_state_ptr;
			yy_lp = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(STR):
case YY_STATE_EOF(ATFORMAT):
case YY_STATE_EOF(ISTATE):
#line 74 "control_lex.l"
{
	if(iflag) {
		iflag=0;
		return BREAK;
	}
	if(--list_ptr<0) yyterminate();
	else {
		free(fname_list[list_ptr+1]);
		yy_delete_buffer(YY_CURRENT_BUFFER);
		yy_switch_to_buffer(bufstate_list[list_ptr]);
		lineno=ln_list[list_ptr];
		lineno1=ln1_list[list_ptr];
		linebuf[0]=linebuf1[0]=0;
	}
}
	YY_BREAK
case 1:
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 90 "control_lex.l"
{ process_env_var(yytext); }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 92 "control_lex.l"
{
    (void)strncpy(linebuf,yytext,LINEBUFSIZE);
    (void)strcpy(linebuf1,linebuf);
    yyless((int)0);
    BEGIN ISTATE;
    }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 99 "control_lex.l"
{tokenpos+=yyleng;}
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 101 "control_lex.l"
{ 
    lineno++;
    tokenpos=0;
    (void)strncpy(linebuf,yytext+1,LINEBUFSIZE);
    yyless((int)1);
    }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 108 "control_lex.l"
BEGIN(COMMENT);
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 109 "control_lex.l"
{tokenpos+=yyleng;}
	YY_BREAK
case 7:
YY_RULE_SETUP
#line 110 "control_lex.l"
{lineno++; tokenpos=0;}
	YY_BREAK
case 8:
YY_RULE_SETUP
#line 111 "control_lex.l"
{BEGIN(ISTATE); tokenpos+=yyleng;}
	YY_BREAK
case 9:
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */
yy_c_buf_p = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 113 "control_lex.l"
;
	YY_BREAK
case 10:
YY_RULE_SETUP
#line 115 "control_lex.l"
{ stringbuf_ptr=0;
       BEGIN(STR);
 	  tokenpos+=yyleng; }
	YY_BREAK
case 11:
YY_RULE_SETUP
#line 119 "control_lex.l"
{
           BEGIN(ISTATE);
	      append_to_sbuf(&stringbuf_ptr,'\0');
		 yylval.string=get_string(stringbuf,stringbuf_ptr);
		 tokenpos+=yyleng;
		 return STRING; 
	   }
	YY_BREAK
case 12:
YY_RULE_SETUP
#line 127 "control_lex.l"
{ BEGIN(ISTATE);
	     append_to_sbuf(&stringbuf_ptr,'\0');
		print_scan_warn("Line %d: Warning - Unterminanted string\n",lineno);
		tokenpos+=yyleng;
		yylval.string=get_string(stringbuf,stringbuf_ptr);
		return STRING; }
	YY_BREAK
case 13:
YY_RULE_SETUP
#line 134 "control_lex.l"
{ unsigned int result;
                    (void) sscanf(yytext+1,"%uo",&result);
				tokenpos+=yyleng;
				if(result>0xff) print_scan_err("Line %d: Error - Octal constant too large\n",lineno);
				append_to_sbuf(&stringbuf_ptr,(char)result); }
	YY_BREAK
case 14:
YY_RULE_SETUP
#line 140 "control_lex.l"
{ unsigned int result;
                    (void) sscanf(yytext+1,"%ux",&result);
				tokenpos+=yyleng;
 				append_to_sbuf(&stringbuf_ptr,(char)result); }
	YY_BREAK
case 15:
YY_RULE_SETUP
#line 145 "control_lex.l"
{ tokenpos+=yyleng;
                print_scan_err("Line %d: Error - Syntax error in escape sequence\n",lineno); }
	YY_BREAK
case 16:
YY_RULE_SETUP
#line 148 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\a'); }
	YY_BREAK
case 17:
YY_RULE_SETUP
#line 151 "control_lex.l"
{ tokenpos+=yyleng;
 	     append_to_sbuf(&stringbuf_ptr,'\b'); }
	YY_BREAK
case 18:
YY_RULE_SETUP
#line 154 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\f'); }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 157 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\n'); }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 160 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\r'); }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 163 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\t'); }
	YY_BREAK
case 22:
YY_RULE_SETUP
#line 166 "control_lex.l"
{ tokenpos+=yyleng;
	     append_to_sbuf(&stringbuf_ptr,'\v'); }
	YY_BREAK
case 23:
YY_RULE_SETUP
#line 169 "control_lex.l"
{ tokenpos++;
	     append_to_sbuf(&stringbuf_ptr,'\a'); }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 172 "control_lex.l"
{ char *ss=yytext;
                  tokenpos+=yyleng;
			   while(*ss) append_to_sbuf(&stringbuf_ptr,*ss++); }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 176 "control_lex.l"
{ if(at_file) BEGIN ATFORMAT;
     tokenpos+=yyleng;
     return '['; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 180 "control_lex.l"
{ if(at_file) BEGIN ISTATE;
              tokenpos+=yyleng;
              return ']'; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 184 "control_lex.l"
{ tokenpos+=yyleng; return('x'); }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 186 "control_lex.l"
{ tokenpos+=yyleng; return('y'); }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 188 "control_lex.l"
{ return LEQSYMBOL; }
	YY_BREAK
case 30:
YY_RULE_SETUP
#line 190 "control_lex.l"
{ return GEQSYMBOL; }
	YY_BREAK
case 31:
YY_RULE_SETUP
#line 192 "control_lex.l"
{ return NEQSYMBOL; }
	YY_BREAK
case 32:
YY_RULE_SETUP
#line 194 "control_lex.l"
{ return '='; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 196 "control_lex.l"
{ return ORSYMBOL; }
	YY_BREAK
case 34:
YY_RULE_SETUP
#line 198 "control_lex.l"
{ return ANDSYMBOL; }
	YY_BREAK
case 35:
YY_RULE_SETUP
#line 200 "control_lex.l"
{ return NOTSYMBOL; }
	YY_BREAK
case 36:
YY_RULE_SETUP
#line 202 "control_lex.l"
{ return SKIPFORMAT; }
	YY_BREAK
case 37:
YY_RULE_SETUP
#line 203 "control_lex.l"
{ if(at_file) return SKIPFORMAT;
								  if(!ff_flag) {yyless(0); token=BREAK;}			 
                          else token=SKIPFORMAT;
	                       ff_flag^=1;
	                       return token; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 208 "control_lex.l"
{ return RSFORMAT; }
	YY_BREAK
case 39:
YY_RULE_SETUP
#line 209 "control_lex.l"
{ if(at_file) return RSFORMAT;
								  if(!ff_flag) {yyless(0); token=BREAK;}
                          else token=RSFORMAT;
	                       ff_flag^=1;
	                       return token; }
	YY_BREAK
case 40:
YY_RULE_SETUP
#line 214 "control_lex.l"
{ return GSFORMAT; }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 215 "control_lex.l"
{ if(at_file) return GSFORMAT;
								  if(!ff_flag) {yyless(0); token=BREAK;}
                          else token=GSFORMAT;
	                       ff_flag^=1;
	                       return token; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 221 "control_lex.l"
{ return FSFORMAT; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 222 "control_lex.l"
{ if(at_file) return FSFORMAT;
								  if(!ff_flag) {yyless(0); token=BREAK;}
                          else token=FSFORMAT;
	                       ff_flag^=1;
	                       return token; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 228 "control_lex.l"
{
                               token=symbol_lookup(yytext,1);
				           if(token==BREAK) yyless(0);
				           else
						 {
						   tokenpos+=yyleng;
						   if(!at_model && !at_use && (token==VARIABLE || token==ARRAY_VAR)) token=ASSIGN;
						 }
						 if((!at_model && !at_use) || token!=BREAK) return token;
					    }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 239 "control_lex.l"
{
	             token=symbol_lookup(yytext,0);
				    if(token==BREAK) yyless(0);
				    else tokenpos+=yyleng; 
				    return token; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 245 "control_lex.l"
{
         tokenpos+=yyleng; yylval.rvalue=atof(yytext); return REAL; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 248 "control_lex.l"
{ tokenpos+=yyleng; yylval.value=atoi(yytext); return INTEGER; }
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 250 "control_lex.l"
{ tokenpos+=yyleng; return yytext[0]; }
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 252 "control_lex.l"
ECHO;
	YY_BREAK
#line 1580 "lex.yy.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );

		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;
	yy_state_ptr = yy_state_buf;
	*yy_state_ptr++ = yy_current_state;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 229 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		*yy_state_ptr++ = yy_current_state;
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;

	register YY_CHAR yy_c = 1;
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 229 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 228);
	if ( ! yy_is_jam )
		*yy_state_ptr++ = yy_current_state;

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_current_buffer->yy_n_chars =
			yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}
#endif	/* ifndef YY_NO_UNPUT */


#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						return EOF;

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;


	return c;
	}


#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}


#ifndef YY_ALWAYS_INTERACTIVE
#ifndef YY_NEVER_INTERACTIVE
extern int isatty YY_PROTO(( int ));
#endif
#endif

#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


	{
	int oerrno = errno;

	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
	b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
	b->yy_is_interactive = 0;
#else
	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	errno = oerrno;
	}


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
	{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
	{
	int len;
	for ( len = 0; yy_str[len]; ++len )
		;

	return yy_scan_bytes( yy_str, len );
	}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
	{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_flex_alloc( n );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif
#line 252 "control_lex.l"

/*"*/

int yywrap(void) 
{
	return 1;
}
	
void yyerror(char *s)
{
     int i;
	
	if(loop_record== -1)	{
		print_scan_err("File %s, line %d: %s\n",fname_list[list_ptr],lineno,s);
		loop_record= -2;
	}
	else if(loop_record>=0)	{
		print_scan_err("File %s, line %d: %s\n%s\n",fname_list[list_ptr],lineno,s,linebuf);
		if(scan_error_n<=max_scan_errors && linebuf[0]) {
			for(i=1;i<tokenpos;i++) (void)putc('-',stderr);
			(void)fputs("^\n",stderr);
		}
	}
	scan_error|=SCAN_ERR;
}

void yyerror1(char *s)
{
	if(loop_record== -1)	{
		print_scan_err("File %s, line %d: %s\n",fname_list[list_ptr],lineno1,s);
		loop_record= -2;
	} else if(loop_record>=0) print_scan_err("File %s, line %d: %s\n%s\n",fname_list[list_ptr],lineno1,s,linebuf1);
	scan_error|=SCAN_ERR;
}

void include_control_file(char *fname)
{
	FILE *fptr;
	YY_BUFFER_STATE ystate;
	int i,j;
	struct stat st1,st2;
	  
	if(fname) {
		if(!fname[0]) yyerror1("Null filename from INCLUDE command\n");
		if(stat(fname,&st1)) {
			(void)fprintf(stderr,"File: %s\n",fname);	
			yyerror1("Include file could not be stat()'d\n");
			perror(0);
			exit(EXIT_FAILURE);
		}
		for(i=0;i<=list_ptr;i++) {
			if(stat(fname_list[i],&st2)) {
				(void)fprintf(stderr,"File: %s\n",fname_list[i]);	
				yyerror1("Include file could not be stat()'d\n");
				perror(0);
				exit(EXIT_FAILURE);
			}
			if(st1.st_ino==st2.st_ino && st1.st_dev==st2.st_dev) {
				for(j=0;j<=list_ptr;j++) {
					if(j==i) (void)fprintf(stderr,"*%s* -> ",fname_list[j]);
					else (void)fprintf(stderr,"%s -> ",fname_list[j]);
				}
				(void)fprintf(stderr,"%s\n",fname);
				yyerror1("Recursive include files!\n");
				exit(EXIT_FAILURE);
			}
		}
		if(list_ptr<MAX_INCLUDE) {
			if(!(fptr=fopen(fname,"r"))) {
				yyerror1("Include file could not be opened");
				perror(0);
				exit(EXIT_FAILURE);
			}
			bufstate_list[list_ptr]=YY_CURRENT_BUFFER;
			ln_list[list_ptr]=lineno;
			ln1_list[list_ptr]=lineno1;
			lineno=lineno1=1;
			linebuf[0]=linebuf1[0]=0;
			fname_list[++list_ptr]=fname;
			ystate=yy_create_buffer(fptr,YY_BUF_SIZE);
			yy_switch_to_buffer(ystate);
		} else yyerror("Too many nested includes\n");
	}
}
  
static void append_to_sbuf(int *sptr,char c)
{
	if(*sptr>=MAX_STRING) print_scan_err("Line %d: Maximum string size exceeded",lineno);
	stringbuf[(*sptr)++]=c;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "get_string"
static char *get_string(char *s,int size)
{
	char *s1;
	if(!(s1=malloc(size))) ABT_FUNC(MMsg);
	(void)memcpy(s1,s,size);
	return s1;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "yylex"
int yylex(void)
{
	int tok,i;
	
	if(loop_record==1) {
		tok=yy_orig_lex();
		if(!loop_stack) {
			if(!(loop_stack=malloc(sizeof(struct token_store)*loop_stack_size))) ABT_FUNC(MMsg);
			loop_main_ptr=0;
		} else if(loop_main_ptr==loop_stack_size)	{
			loop_stack_size*=2;
			if(!(loop_stack=realloc(loop_stack,sizeof(struct token_store)*loop_stack_size))) ABT_FUNC(MMsg);
		}
		loop_stack[loop_main_ptr].line=lineno;
		loop_stack[loop_main_ptr].line1=lineno1;
		loop_stack[loop_main_ptr].yylval=yylval;
		if(tok==STRING) yylval.string=copy_string(yylval.string);
		loop_stack[loop_main_ptr++].token=tok;
		return tok;	   
	} else if(loop_record<0) {
		if(in_loopclause== -1) {
			in_loopclause= -2;
			return LOOP_CLAUSE_START;
		}
		yylval=loop_stack[loop_main_ptr].yylval;
		lineno=loop_stack[loop_main_ptr].line;
		lineno1=loop_stack[loop_main_ptr].line1;
		tok=loop_stack[loop_main_ptr++].token;
		if(tok==STRING) yylval.string=copy_string(yylval.string);
		if(in_loopclause) {
			if(tok==',' && loop_stack[loop_main_ptr].token==BREAK) {
				loop_clause_element->arg.value+=loop_clause_step;
				if(loop_clause_element->arg.value==loop_clause_end) i=0;
				else {
					i=(loop_clause_element->arg.value>loop_clause_end);
					if(loop_clause_step<0) i=1-i;
				}
				if(i) {
					loop_record=loop_stat[--loop_level];
					if(!loop_record) loop_main_ptr=loop_level?loop_ptr[loop_level-1]:0;
					else loop_main_ptr=loop_clause_ptr;
					in_loopclause=0;
					return LOOP_CLAUSE_END;
				} else loop_main_ptr=loop_ptr[loop_level-1];
			}
		}
		return tok;
	}
	/* Dummy call to shut up compiler warnings about yy_flex_realloc() not being used */
	if(0) (void)yy_flex_realloc(0,0);
	return yy_orig_lex();
}

void yy_cleanup(void)
{
	yy_delete_buffer(yy_current_buffer);
	if(loop_stack) free(loop_stack);
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "process_env_var"
static void process_env_var(char *ptr)
{
	int i=0,j,k,size=512,brack;
	char *s,old,*stringptr;
	
	if(!(stringptr=malloc(size))) ABT_FUNC(MMsg);
	for(;;) {
		while(*ptr && *ptr!='$') {
			if(i>=size) {
				size+=size;
				if(!(stringptr=realloc(stringptr,size))) ABT_FUNC(MMsg);
			}
			stringptr[i++] = *(ptr++);
		}
		if(!(*ptr)) break;
		ptr++;
		j=0;
		brack=0;
		if(*ptr=='(') {
			ptr++;
			while(ptr[j] && ptr[j]!=')') j++;
			if(ptr[j]==')') brack=1;
		} else {
			while(isalnum((int)ptr[j]) || ptr[j]=='_') j++;
		}
		old=ptr[j];
		ptr[j]=0;
		if((s=getenv(ptr))) {
			if((k=strlen(s)))	{
				if(k+i>=size) {
					while(k+i>size) size+=size;
					if(!(stringptr=realloc(stringptr,size))) ABT_FUNC(MMsg);
				}
				(void)memcpy(stringptr+i,s,k);
				i+=k;
			}
		}
		ptr[j]=old;
		ptr+=j+brack;
	}
	while(i) unput(stringptr[--i]);
	free(stringptr);
}
