/* A Bison parser, made from control_parse.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

# define	FILEC	257
# define	MARKER	258
# define	LOCUS	259
# define	TRAIT	260
# define	RANDOM	261
# define	PEDIGREE	262
# define	LOG	263
# define	MODEL	264
# define	FILTER	265
# define	LINK	266
# define	MISSING	267
# define	FACTOR	268
# define	BREAK	269
# define	DOLOOP	270
# define	WHILE	271
# define	USE	272
# define	WHERE	273
# define	ORSYMBOL	274
# define	ANDSYMBOL	275
# define	NEQSYMBOL	276
# define	LEQSYMBOL	277
# define	GEQSYMBOL	278
# define	NOTSYMBOL	279
# define	LOGICAL	280
# define	SHELL	281
# define	ARRAY	282
# define	PRINTEXP	283
# define	INCLUDE	284
# define	RAWOUTPUT	285
# define	LOOP_CLAUSE_START	286
# define	LOOP_CLAUSE_END	287
# define	CONSTANT	288
# define	MULTIPLE	289
# define	RSFORMAT	290
# define	FSFORMAT	291
# define	SKIPFORMAT	292
# define	GSFORMAT	293
# define	CENSORED	294
# define	GROUP	295
# define	SET	296
# define	GENDER	297
# define	AFFECTED	298
# define	OUTPUT	299
# define	ERRORDIR	300
# define	LAUROUTPUT	301
# define	STRING	302
# define	VARIABLE	303
# define	ASSIGN	304
# define	ARRAY_VAR	305
# define	INTEGER	306
# define	SYSTEM_VAR	307
# define	REAL	308
# define	UMINUS	309

#line 1 "control_parse.y"

/****************************************************************************
 *                                                                          *
 *     Loki - Programs for genetic analysis of complex traits using MCMC    *
 *                                                                          *
 *             Simon Heath - University of Washington                       *
 *                                                                          *
 *                       March 1997                                         *
 *                                                                          *
 * control_parse.y:                                                         *
 *                                                                          *
 * yacc source for control file parser.                                     *
 *                                                                          *
 * Copyright (C) Simon C. Heath 1997, 2000, 2002                            *
 * This is free software.  You can distribute it and/or modify it           *
 * under the terms of the Modified BSD license, see the file COPYING        *
 *                                                                          *
 ****************************************************************************/

#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
#ifdef USE_DMALLOC
#include <dmalloc.h>
#endif
#include <stdio.h>
#include <math.h>
#include <ctype.h>

#include "utils.h"
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 0
#endif
#ifndef __GNUC__
#define __GNUC__ 0
#endif


#line 43 "control_parse.y"
#ifndef YYSTYPE
typedef union 
{
	char *string;
	struct bin_node *var;
	int value;
	double rvalue;
	struct format_clause *format_clause;
	struct fformat *fformat;
	struct format_atom *f_atom;
	struct model_list *model_list;
	struct var_list *var_list;
	struct var_element *element;
	struct express *express;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#line 88 "control_parse.y"

#include "scan.h"
#include "scanner.h"

static struct format_atom *make_f_atom(int,int);
static struct format_clause *add_f_atom(struct format_clause *,struct format_atom *);
static struct format_clause *add_f_list(struct format_clause *,struct format_clause *,int);
static struct format *setup_format(struct format_clause *);
static struct bin_node *create_var(char *p);
static struct model_list *add_to_model(struct model_list *,struct var_list *);
static struct var_list *add_to_var_list(struct var_list *,struct bin_node *,struct express *express);
static struct var_list *add_var_lists(struct var_list *,struct var_list *);
static struct var_element *get_element(struct bin_node *var,struct express *express);
static struct var_element *assign_var(struct bin_node *var,struct express *ix,struct express *express);
static struct express *alloc_express(void);
static struct express *do_express_op(struct express *ex1,struct express *ex2,int op);
static struct express *do_logical_op(struct express *ex1,struct express *ex2,int op);
static struct fformat *add_fformat(struct fformat *f1,struct fformat *f2);
static struct fformat *create_fformat(void *s,int fg);
static void begin_looping(struct var_element *element, struct express *exp1, struct express *exp2);
static void free_vlist(struct var_list *vlist);
static void do_ped_com(struct var_list *vlist);
static void add_restriction(struct var_list *);
static void add_censored(struct var_element *,const int fg);
static void do_file_com(char *fname,struct format_clause *fc,struct fformat *ff,struct var_list *vlist);
static void set_locus_element(struct var_element *);
static void set_haplo_element(struct var_element *,struct var_element *);
static void do_link_com(char *s,int type, struct var_list *);
static void do_missing_com(char *,struct var_list *,char *);
static void change_type(int,struct var_list *);
static void do_model_com(struct model_list *,struct bin_node *,struct express *);
static void add_operation(void *,int,int);
static void set_array_var(struct scan_data *,struct express *);
static void check_element_add_op(struct var_element *);
static void enter_loop(void);
static void start_loopclause(void);
static void do_while_com(struct express *);
static void print_exp(struct express *);
static void new_command(void);
static void set_sex(struct var_element *,struct express *,struct express *);
static void set_group(struct var_element *);
static int count_var_list(struct var_list *),shell_flag;
static struct format_atom *f_atom_list;
static struct var_element *pedlist[4];
static int f_atom_n,f_atom_size=32,pedflag;
struct operation *Affected;
struct bin_node *root_var;
struct InFile *Infiles;
struct Link *links;
struct Miss *Miss;
struct Restrict *Restrictions;
struct Censor *Censored;
struct model *Models;
static struct operation *Op_List;
struct Marker *markers,*traitlocus;
static struct var_element *hap_list[2];
struct express *sex_exp[2];
struct var_element *sex_elem,*group_elem;
static char *string_copy(char *s1,char *s2);
static char *LogFile;

int scan_error,scan_error_n,scan_warn_n;
int max_scan_errors=30,max_scan_warnings=30,n_markers,iflag,file_skip;
char *Filter,*ErrorDir,*rsformat,*fsformat,*gsformat,*OutputFile,*OutputRawFile,*OutputLaurFile;
int loop_level,loop_ptr[MAX_LOOP],loop_stat[MAX_LOOP],loop_record,loop_stack_size=256;
int loop_main_ptr,in_loopclause,loop_clause_end,loop_clause_step,loop_clause_ptr;
int syst_var[NUM_SYSTEM_VAR];
int family_id;
struct var_element *loop_clause_element;
struct token_store *loop_stack;
	  
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		380
#define	YYFLAG		-32768
#define	YYNTBASE	72

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 309 ? yytranslate[x] : 128)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      64,    65,    60,    58,    66,    59,    61,    62,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    69,
      56,    55,    57,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    67,     2,    68,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      70,    71,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    63
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     2,     4,     7,    11,    15,    17,    19,    21,
      23,    25,    27,    29,    31,    33,    35,    37,    39,    41,
      43,    45,    47,    49,    51,    53,    55,    57,    59,    61,
      63,    65,    67,    71,    78,    80,    82,    84,    86,    90,
      94,    98,   102,   105,   109,   113,   117,   119,   120,   124,
     131,   137,   143,   148,   150,   154,   158,   162,   166,   170,
     174,   178,   182,   185,   188,   190,   194,   197,   200,   203,
     206,   209,   214,   221,   228,   234,   241,   246,   248,   250,
     252,   254,   258,   262,   266,   270,   274,   277,   281,   285,
     289,   293,   297,   301,   305,   309,   312,   317,   325,   333,
     335,   340,   342,   346,   351,   358,   360,   364,   368,   371,
     374,   377,   380,   382,   385,   387,   390,   392,   395,   398,
     401,   404,   407,   410,   414,   419,   425,   428,   432,   436,
     439,   442,   445,   448,   451,   454,   456,   461,   466,   469,
     474,   477,   480,   485,   493,   496,   500,   504,   506,   508,
     512,   516,   520,   524,   526,   528,   533,   535,   540,   542,
     546,   549,   551,   555,   561,   565,   567,   571,   573,   582,
     593,   598,   600,   601,   603,   605,   610,   612,   614,   618,
     622,   624,   626,   630,   634,   636,   640,   644,   646,   648,
     652
};
static const short yyrhs[] =
{
      73,     0,     1,     0,    72,    15,     0,    72,    15,    73,
       0,    72,    15,     1,     0,    94,     0,   109,     0,    79,
       0,   100,     0,   104,     0,   105,     0,   106,     0,   108,
       0,   110,     0,   103,     0,    91,     0,    92,     0,    74,
       0,    89,     0,    86,     0,    78,     0,    84,     0,    81,
       0,    82,     0,   111,     0,    77,     0,    88,     0,    83,
       0,   101,     0,   102,     0,    75,     0,    50,    55,    76,
       0,    50,    64,    76,    65,    55,    76,     0,    54,     0,
      52,     0,    48,     0,   115,     0,    76,    58,    76,     0,
      76,    59,    76,     0,    76,    60,    76,     0,    76,    62,
      76,     0,    59,    76,     0,    64,    76,    65,     0,    42,
      53,    52,     0,    42,    49,    52,     0,    16,     0,     0,
      30,    80,   127,     0,    40,   115,    19,    64,    93,    65,
       0,    44,    19,    64,    93,    65,     0,    43,   115,    76,
      66,    76,     0,    17,    64,    85,    65,     0,    76,     0,
      85,    55,    85,     0,    85,    22,    85,     0,    85,    23,
      85,     0,    85,    24,    85,     0,    85,    56,    85,     0,
      85,    57,    85,     0,    85,    20,    85,     0,    85,    21,
      85,     0,    25,    85,     0,    29,    87,     0,    76,     0,
      87,    66,    76,     0,    36,   127,     0,    37,   127,     0,
      39,   127,     0,    38,    52,     0,    28,    90,     0,    49,
      64,    76,    65,     0,    90,    66,    49,    64,    76,    65,
       0,    18,   125,    19,    64,    93,    65,     0,    18,    19,
      64,    93,    65,     0,    19,    64,    93,    65,    18,   125,
       0,    19,    64,    93,    65,     0,    52,     0,    54,     0,
      48,     0,   115,     0,    93,    58,    93,     0,    93,    59,
      93,     0,    93,    60,    93,     0,    93,    62,    93,     0,
      64,    93,    65,     0,    59,    93,     0,    93,    55,    93,
       0,    93,    22,    93,     0,    93,    23,    93,     0,    93,
      24,    93,     0,    93,    56,    93,     0,    93,    57,    93,
       0,    93,    20,    93,     0,    93,    21,    93,     0,    25,
      93,     0,     3,    95,    66,   124,     0,     3,    67,    96,
      68,    95,    66,   124,     0,     3,    67,    97,    68,    95,
      66,   124,     0,   127,     0,    27,    64,   127,    65,     0,
      99,     0,    96,    66,    99,     0,    52,    64,    96,    65,
       0,    96,    66,    52,    64,    96,    65,     0,    98,     0,
      97,    66,    98,     0,    97,    69,    98,     0,    37,   127,
       0,    36,   127,     0,    39,   127,     0,    38,    52,     0,
      52,     0,    52,    70,     0,    70,     0,    52,     1,     0,
       1,     0,     9,   127,     0,    45,   127,     0,    47,   127,
       0,    31,   127,     0,    46,   127,     0,    13,   127,     0,
      13,   127,   125,     0,    13,   127,    66,   125,     0,    13,
      67,   127,    68,   127,     0,     8,   125,     0,     4,     5,
     116,     0,     6,     5,   125,     0,    34,   125,     0,    35,
     125,     0,     7,   125,     0,    14,   125,     0,    54,   125,
       0,    52,   125,     0,    12,     0,    12,    67,    70,    68,
       0,    12,    67,    71,    68,     0,   107,   125,     0,   107,
     126,    66,   125,     0,   107,   126,     0,    11,   127,     0,
      10,    49,    55,   112,     0,    10,    51,    64,    76,    65,
      55,   112,     0,    41,   115,     0,   112,    58,   114,     0,
     112,    58,   113,     0,   113,     0,   114,     0,   114,    60,
     114,     0,   114,    61,   114,     0,   113,    60,   114,     0,
     113,    61,   114,     0,    49,     0,    51,     0,    51,    64,
      76,    65,     0,    49,     0,    51,    64,    76,    65,     0,
     117,     0,   116,    66,   117,     0,   115,   118,     0,   115,
       0,    67,   115,    68,     0,    67,   115,    66,   115,    68,
       0,    67,     1,    68,     0,   114,     0,   119,    66,   114,
       0,    64,     0,   120,   119,    66,    15,    75,    66,    76,
      65,     0,   120,   119,    66,    15,    75,    66,    76,    66,
      76,    65,     0,   121,    32,   119,    33,     0,   121,     0,
       0,    49,     0,    51,     0,    51,    64,    76,    65,     0,
     123,     0,   122,     0,   124,    66,   123,     0,   124,    66,
     122,     0,   114,     0,   122,     0,   125,    66,   114,     0,
     125,    66,   122,     0,    48,     0,   126,    58,    48,     0,
     115,    58,   126,     0,    48,     0,   115,     0,   127,    58,
      48,     0,   127,    58,   115,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   163,   164,   165,   166,   167,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   197,   200,   201,   204,   205,   206,   207,   209,   210,
     211,   212,   213,   214,   217,   218,   221,   224,   224,   227,
     230,   233,   236,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   251,   254,   255,   258,   259,   260,   261,
     264,   266,   267,   270,   271,   274,   275,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   299,   300,   301,   304,
     305,   308,   309,   310,   311,   314,   315,   316,   319,   320,
     321,   322,   325,   326,   327,   328,   329,   332,   336,   337,
     338,   341,   345,   346,   347,   348,   351,   354,   355,   358,
     359,   360,   361,   362,   363,   366,   367,   368,   371,   372,
     373,   376,   384,   385,   388,   391,   392,   393,   394,   397,
     398,   399,   400,   403,   404,   405,   408,   409,   412,   412,
     414,   415,   418,   419,   420,   423,   424,   427,   430,   431,
     434,   435,   438,   439,   440,   441,   444,   445,   446,   447,
     450,   451,   452,   453,   456,   457,   458,   461,   462,   463,
     464
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "FILEC", "MARKER", "LOCUS", "TRAIT", 
  "RANDOM", "PEDIGREE", "LOG", "MODEL", "FILTER", "LINK", "MISSING", 
  "FACTOR", "BREAK", "DOLOOP", "WHILE", "USE", "WHERE", "ORSYMBOL", 
  "ANDSYMBOL", "NEQSYMBOL", "LEQSYMBOL", "GEQSYMBOL", "NOTSYMBOL", 
  "LOGICAL", "SHELL", "ARRAY", "PRINTEXP", "INCLUDE", "RAWOUTPUT", 
  "LOOP_CLAUSE_START", "LOOP_CLAUSE_END", "CONSTANT", "MULTIPLE", 
  "RSFORMAT", "FSFORMAT", "SKIPFORMAT", "GSFORMAT", "CENSORED", "GROUP", 
  "SET", "GENDER", "AFFECTED", "OUTPUT", "ERRORDIR", "LAUROUTPUT", 
  "STRING", "VARIABLE", "ASSIGN", "ARRAY_VAR", "INTEGER", "SYSTEM_VAR", 
  "REAL", "'='", "'<'", "'>'", "'+'", "'-'", "'*'", "'.'", "'/'", 
  "UMINUS", "'('", "')'", "','", "'['", "']'", "';'", "'x'", "'y'", 
  "comfile", "command", "assigncommand", "assignment", "expression", 
  "setcommand", "docommand", "includecommand", "@1", "censorcommand", 
  "affectedcommand", "sexcommand", "whilecommand", "condition", 
  "printcommand", "printlist", "defformatcommand", "arraycommand", 
  "arraylist", "usecommand", "wherecommand", "res_condition", 
  "filecommand", "filename_string", "formatlist", "fformatlist", 
  "fformat", "format", "logcommand", "outputcommand", "errordircommand", 
  "missingcommand", "pedcommand", "locicommand", "changetypecommand", 
  "linkcom1", "linkcommand", "filtercommand", "modelcommand", 
  "groupcommand", "modellist", "interactionlist", "single_vlist", 
  "single_element", "locuslist", "locus", "lociclause", "simple_varlist", 
  "open_bracket", "loop_clause1", "loop_clause", "fsingle_vlist", 
  "filevarlist", "varlist", "complex_string1", "complex_string", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    72,    72,    72,    72,    72,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    73,
      73,    74,    75,    75,    76,    76,    76,    76,    76,    76,
      76,    76,    76,    76,    77,    77,    78,    80,    79,    81,
      82,    83,    84,    85,    85,    85,    85,    85,    85,    85,
      85,    85,    85,    86,    87,    87,    88,    88,    88,    88,
      89,    90,    90,    91,    91,    92,    92,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    93,    93,    93,    93,
      93,    93,    93,    93,    93,    93,    94,    94,    94,    95,
      95,    96,    96,    96,    96,    97,    97,    97,    98,    98,
      98,    98,    99,    99,    99,    99,    99,   100,   101,   101,
     101,   102,   103,   103,   103,   103,   104,   105,   105,   106,
     106,   106,   106,   106,   106,   107,   107,   107,   108,   108,
     108,   109,   110,   110,   111,   112,   112,   112,   112,   113,
     113,   113,   113,   114,   114,   114,   115,   115,   116,   116,
     117,   117,   118,   118,   118,   119,   119,   120,   121,   121,
     122,   122,   123,   123,   123,   123,   124,   124,   124,   124,
     125,   125,   125,   125,   126,   126,   126,   127,   127,   127,
     127
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     1,     1,     2,     3,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     6,     1,     1,     1,     1,     3,     3,
       3,     3,     2,     3,     3,     3,     1,     0,     3,     6,
       5,     5,     4,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     2,     2,     1,     3,     2,     2,     2,     2,
       2,     4,     6,     6,     5,     6,     4,     1,     1,     1,
       1,     3,     3,     3,     3,     3,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     4,     7,     7,     1,
       4,     1,     3,     4,     6,     1,     3,     3,     2,     2,
       2,     2,     1,     2,     1,     2,     1,     2,     2,     2,
       2,     2,     2,     3,     4,     5,     2,     3,     3,     2,
       2,     2,     2,     2,     2,     1,     4,     4,     2,     4,
       2,     2,     4,     7,     2,     3,     3,     1,     1,     3,
       3,     3,     3,     1,     1,     4,     1,     4,     1,     3,
       2,     1,     3,     5,     3,     1,     3,     1,     8,    10,
       4,     1,     0,     1,     1,     4,     1,     1,     3,     3,
       1,     1,     3,     3,     1,     3,     3,     1,     1,     3,
       3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,     2,     0,     0,     0,     0,     0,     0,     0,     0,
     135,     0,     0,    46,     0,     0,     0,     0,     0,    47,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     1,
      18,    31,    26,    21,     8,    23,    24,    28,    22,    20,
      27,    19,    16,    17,     6,     9,    29,    30,    15,    10,
      11,    12,     0,    13,     7,    14,    25,     0,   187,   156,
       0,     0,     0,   188,    99,     0,     0,   153,   154,   167,
     180,     0,   171,   181,   131,   126,   117,     0,     0,   141,
       0,     0,   122,   132,     0,     0,     0,     0,     0,    70,
      36,    35,    34,     0,     0,    64,    63,    37,     0,   120,
     129,   130,    66,    67,    69,    68,     0,   144,     0,     0,
       0,     0,   118,   121,   119,     0,     0,   134,   133,     0,
     184,   153,   154,     0,   138,   140,     0,     0,   116,     0,
       0,     0,     0,     0,   114,     0,     0,   105,   101,   172,
       0,   161,   127,   158,   128,     0,   165,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   123,     0,    53,     0,
       0,     0,     0,    79,    77,    78,     0,     0,     0,    80,
       0,     0,    42,     0,     0,     0,     0,     0,     0,    48,
       0,    45,    44,     0,     0,    32,     0,     5,     4,     0,
       0,     0,     0,     0,     0,   109,   108,   111,   110,   115,
       0,   113,     0,     0,     0,     0,     0,   173,   174,   177,
     176,    96,   189,   190,     0,   160,     0,     0,     0,     0,
     182,   183,   142,   147,   148,     0,   136,   137,     0,   124,
      62,     0,     0,     0,     0,     0,     0,     0,     0,    52,
       0,     0,    95,    86,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    76,     0,     0,
      43,    38,    39,    40,    41,    65,     0,     0,     0,     0,
       0,   186,   185,   139,   100,   157,     0,     0,   102,     0,
     106,     0,   107,     0,   172,     0,     0,   159,   155,     0,
     166,   170,     0,     0,     0,     0,     0,     0,     0,   125,
      60,    61,    55,    56,    57,    54,    58,    59,    74,     0,
      85,    93,    94,    88,    89,    90,    87,    91,    92,    81,
      82,    83,    84,     0,    71,     0,     0,    51,    50,     0,
     155,   103,     0,   172,   172,     0,   179,   178,   164,     0,
     162,     0,   146,   145,   151,   152,   149,   150,     0,    73,
      75,     0,    49,    33,     0,    97,    98,   175,     0,     0,
     143,    72,   104,   163,     0,   168,     0,     0,   169,     0,
       0
};

static const short yydefgoto[] =
{
      38,    39,    40,    41,   168,    42,    43,    44,   108,    45,
      46,    47,    48,   169,    49,   106,    50,    51,    99,    52,
      53,   178,    54,    72,   145,   146,   147,   148,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
     232,   233,    80,   107,   152,   153,   225,   157,    81,    82,
      83,   220,   221,    84,   135,    74
};

static const short yypact[] =
{
     412,-32768,   124,     1,    14,    89,    89,   169,    -2,   169,
     -64,   156,    89,-32768,   -39,   101,   -36,     9,   562,-32768,
     169,    89,    89,   169,   169,    20,   169,    55,    55,    63,
      55,    60,   169,   169,   169,   -41,    89,    89,     7,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,   225,-32768,-32768,-32768,-32768,    71,-32768,-32768,
      75,    17,    78,-32768,    91,    55,    89,-32768,    93,-32768,
  -32768,   144,   128,-32768,    98,    98,    91,   116,   158,    91,
      47,   169,   290,    98,   517,   219,   -14,   553,   242,   177,
  -32768,-32768,-32768,   562,   562,   166,   194,-32768,   169,    91,
      98,    98,    91,    91,-32768,    91,   297,-32768,   271,   277,
     562,   276,    91,    91,    91,   562,   562,    98,    98,   360,
  -32768,   279,   286,   295,    98,     5,   169,   562,-32768,   169,
     169,   313,   169,    45,-32768,    33,   111,-32768,-32768,   110,
     447,   316,   345,-32768,    98,   562,-32768,   351,   144,    89,
     144,   562,   359,   364,   -48,    89,    98,   517,   166,   257,
     553,   374,   553,-32768,-32768,-32768,   553,   553,   287,-32768,
     562,   390,-32768,   273,   562,   562,   562,   562,   562,    91,
     380,-32768,-32768,    30,   553,   166,   322,-32768,-32768,   562,
     504,   397,    89,   -34,   448,    91,    91,-32768,    91,-32768,
       8,-32768,    10,    -6,   449,    -6,   449,-32768,   396,-32768,
  -32768,   395,-32768,-32768,    26,-32768,    55,   515,    49,   -29,
  -32768,-32768,   405,   138,   325,   574,-32768,-32768,   169,    98,
  -32768,   517,   517,   517,   517,   517,   517,   517,   517,-32768,
     413,   553,-32768,-32768,   459,   553,   553,   553,   553,   553,
     553,   553,   553,   553,   553,   553,   553,   456,   582,   401,
  -32768,   148,   148,-32768,-32768,   166,   553,   562,   470,   421,
     590,-32768,-32768,    98,-32768,-32768,   119,    66,-32768,   411,
  -32768,   418,-32768,   562,   110,   399,   161,-32768,-32768,   439,
  -32768,-32768,   144,   144,   144,   144,   144,   144,   442,    91,
     263,   179,   131,-32768,-32768,   131,-32768,-32768,-32768,   481,
  -32768,   538,   190,   268,   196,   196,   268,   196,   196,   191,
     191,-32768,-32768,    89,-32768,   562,   527,   166,-32768,   562,
     441,-32768,     8,   110,   110,   598,-32768,-32768,-32768,    55,
  -32768,   434,   138,   325,-32768,-32768,-32768,-32768,   144,-32768,
      98,   606,-32768,   166,   327,   395,   395,-32768,   443,   562,
     405,-32768,-32768,-32768,   565,-32768,   562,   614,-32768,   509,
  -32768
};

static const short yypgoto[] =
{
  -32768,   383,-32768,   221,   -18,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,  -119,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,    39,-32768,   121,  -209,-32768,   143,   310,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
     165,   228,   -65,     6,-32768,   307,-32768,   376,-32768,-32768,
    -147,   250,    65,    29,   354,    50
};


#define	YYLAST		679


static const short yytable[] =
{
     105,   286,   219,    90,   301,   171,    75,   379,    73,   138,
     150,   138,   231,    73,   125,    73,   156,    73,   138,    76,
     238,    67,   129,   126,   150,    94,    73,   295,    97,    73,
      73,   284,    73,   116,   117,    85,   120,   302,    73,    73,
      73,    93,    68,    69,    96,    70,   209,    87,   240,    88,
     110,   111,   159,   139,   140,   141,   142,    86,    98,    89,
     143,    92,   287,   201,   299,   127,   128,   209,   133,   143,
     109,   202,   114,   112,   113,    69,   115,    70,   144,   121,
     144,   151,   122,   123,   124,   182,   183,   144,   184,   185,
     186,   134,   187,   156,   230,   234,   277,    73,    77,   212,
      78,   213,   193,   179,    69,   154,    70,   195,   196,   210,
    -112,  -112,   118,  -112,    73,   211,   119,   162,   163,   204,
      95,   166,   310,   311,   312,   313,   314,   315,   316,   317,
     342,  -112,  -112,   364,  -112,   136,   211,   227,    77,   137,
      78,   164,    73,   235,   149,    73,    73,   346,    73,   150,
      77,    67,    78,    79,   244,   245,   223,   155,   189,   217,
     158,   218,   268,   300,   159,    79,   271,   272,   273,   274,
     275,   160,    68,    69,    79,    70,   179,   214,   179,   215,
     216,   280,   179,   179,   341,   212,   203,   247,   248,   205,
     206,    71,   208,    77,   239,    78,   219,   219,   304,   305,
     179,   243,   244,   245,    68,    69,   133,    70,   186,   250,
     187,   252,   257,   258,   259,   253,   254,    68,    69,    73,
      70,    73,   161,    91,   184,   185,   186,   349,   187,   350,
     296,   283,   151,   278,   246,   247,   248,   300,   353,   354,
     355,   356,   357,   181,    73,   260,   261,   262,   263,   264,
     265,   265,   266,   266,   263,   264,   265,   179,   266,   337,
     188,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   130,   131,   345,   132,   241,   242,   243,
     244,   245,   179,   170,   242,   243,   244,   245,   309,    79,
     319,   258,   259,   234,   321,   322,   323,   324,   325,   326,
     327,   328,   329,   330,   331,   332,   180,   255,   256,   257,
     258,   259,   246,   247,   248,   336,   190,   361,   246,   247,
     248,   363,   249,   191,   261,   262,   263,   264,   265,   192,
     266,   184,   185,   186,   289,   187,   291,  -156,   270,    77,
     194,    78,   260,   261,   262,   263,   264,   265,   150,   266,
     199,   374,   267,   200,    79,   368,   165,   290,   377,   292,
      -3,   197,   360,     2,     3,   207,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    -3,    13,    14,    15,    16,
     184,   185,   186,   224,   187,   306,   307,   279,    17,    18,
      19,    20,   372,   212,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,   365,   366,
      35,   226,    36,     1,    37,     2,     3,   228,     4,     5,
       6,     7,     8,     9,    10,    11,    12,   236,    13,    14,
      15,    16,   237,   255,   256,   257,   258,   259,   251,   269,
      17,    18,    19,    20,   276,   282,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
     293,   294,    35,   303,    36,   335,    37,   348,   260,   261,
     262,   263,   264,   265,   333,   266,   339,   343,   318,   255,
     256,   257,   258,   259,   344,   139,   140,   141,   142,    35,
     255,   256,   257,   258,   259,   222,    69,   358,    70,  -157,
     369,   255,   256,   257,   258,   259,   184,   185,   186,   380,
     187,   373,   198,   285,   260,   261,   262,   263,   264,   265,
     351,   266,   288,   370,   320,   260,   261,   262,   263,   264,
     265,   352,   266,   297,   229,   338,   260,   261,   262,   263,
     264,   265,   167,   266,   347,     0,   359,   255,   256,   257,
     258,   259,   130,    69,   281,    70,     0,     0,     0,   256,
     257,   258,   259,     0,     0,   100,    69,     0,    70,   101,
       0,   102,     0,   184,   185,   186,   103,   187,   172,     0,
     298,   104,   260,   261,   262,   263,   264,   265,     0,   266,
       0,     0,   362,   260,   261,   262,   263,   264,   265,     0,
     266,   173,    69,     0,    70,   174,     0,   175,     0,     0,
     100,    69,   176,    70,   101,     0,   102,   177,     0,     0,
       0,   103,     0,   184,   185,   186,   104,   187,     0,     0,
     375,   376,   184,   185,   186,     0,   187,     0,     0,   308,
     184,   185,   186,     0,   187,     0,     0,   334,   184,   185,
     186,     0,   187,     0,     0,   340,   184,   185,   186,     0,
     187,     0,     0,   367,   184,   185,   186,     0,   187,     0,
       0,   371,   184,   185,   186,     0,   187,     0,     0,   378
};

static const short yycheck[] =
{
      18,   210,   149,    67,    33,    19,     5,     0,     2,     1,
      58,     1,   159,     7,    55,     9,    81,    11,     1,     5,
      68,    27,    15,    64,    58,    64,    20,     1,    64,    23,
      24,    65,    26,    27,    28,     6,    30,    66,    32,    33,
      34,    12,    48,    49,    15,    51,     1,    49,   167,    51,
      21,    22,    66,    36,    37,    38,    39,     7,    49,     9,
      52,    11,    52,    58,    15,    36,    37,     1,    62,    52,
      20,    66,    52,    23,    24,    49,    26,    51,    70,    19,
      70,    75,    32,    33,    34,   103,   104,    70,    58,    59,
      60,    62,    62,   158,   159,   160,    66,    91,    49,    66,
      51,    68,   120,    97,    49,    76,    51,   125,   126,    64,
      65,    66,    49,    68,   108,    70,    53,    70,    71,   137,
      19,    92,   241,   242,   243,   244,   245,   246,   247,   248,
      64,    65,    66,   342,    68,    64,    70,   155,    49,    64,
      51,    91,   136,   161,    66,   139,   140,   294,   142,    58,
      49,    27,    51,    64,    23,    24,   150,    64,   108,    49,
      32,    51,   180,   228,    66,    64,   184,   185,   186,   187,
     188,    55,    48,    49,    64,    51,   170,    66,   172,    68,
      69,   199,   176,   177,    65,    66,   136,    56,    57,   139,
     140,    67,   142,    49,   165,    51,   343,   344,    60,    61,
     194,    22,    23,    24,    48,    49,   200,    51,    60,   170,
      62,   172,    22,    23,    24,   176,   177,    48,    49,   213,
      51,   215,    64,    67,    58,    59,    60,    66,    62,    68,
     224,   202,   226,   194,    55,    56,    57,   302,   303,   304,
     305,   306,   307,    66,   238,    55,    56,    57,    58,    59,
      60,    60,    62,    62,    58,    59,    60,   251,    62,   277,
      66,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     264,   265,   266,    48,    49,   293,    51,    20,    21,    22,
      23,    24,   276,    64,    21,    22,    23,    24,   238,    64,
     251,    23,    24,   358,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   264,   265,   266,    64,    20,    21,    22,
      23,    24,    55,    56,    57,   276,    19,   335,    55,    56,
      57,   339,    65,    52,    56,    57,    58,    59,    60,    52,
      62,    58,    59,    60,   213,    62,   215,    58,    65,    49,
      64,    51,    55,    56,    57,    58,    59,    60,    58,    62,
      64,   369,    65,    58,    64,   349,    66,   214,   376,   216,
       0,     1,   333,     3,     4,    52,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      58,    59,    60,    67,    62,    60,    61,    65,    28,    29,
      30,    31,    65,    66,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,   343,   344,
      50,    66,    52,     1,    54,     3,     4,    66,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    68,    16,    17,
      18,    19,    68,    20,    21,    22,    23,    24,    64,    49,
      28,    29,    30,    31,    64,    48,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      64,    66,    50,    58,    52,    64,    54,    68,    55,    56,
      57,    58,    59,    60,    18,    62,    55,    66,    65,    20,
      21,    22,    23,    24,    66,    36,    37,    38,    39,    50,
      20,    21,    22,    23,    24,    48,    49,    55,    51,    58,
      66,    20,    21,    22,    23,    24,    58,    59,    60,     0,
      62,    68,   129,    65,    55,    56,    57,    58,    59,    60,
     299,    62,   212,   358,    65,    55,    56,    57,    58,    59,
      60,   303,    62,   226,   158,    65,    55,    56,    57,    58,
      59,    60,    25,    62,   294,    -1,    65,    20,    21,    22,
      23,    24,    48,    49,   200,    51,    -1,    -1,    -1,    21,
      22,    23,    24,    -1,    -1,    48,    49,    -1,    51,    52,
      -1,    54,    -1,    58,    59,    60,    59,    62,    25,    -1,
      65,    64,    55,    56,    57,    58,    59,    60,    -1,    62,
      -1,    -1,    65,    55,    56,    57,    58,    59,    60,    -1,
      62,    48,    49,    -1,    51,    52,    -1,    54,    -1,    -1,
      48,    49,    59,    51,    52,    -1,    54,    64,    -1,    -1,
      -1,    59,    -1,    58,    59,    60,    64,    62,    -1,    -1,
      65,    66,    58,    59,    60,    -1,    62,    -1,    -1,    65,
      58,    59,    60,    -1,    62,    -1,    -1,    65,    58,    59,
      60,    -1,    62,    -1,    -1,    65,    58,    59,    60,    -1,
      62,    -1,    -1,    65,    58,    59,    60,    -1,    62,    -1,
      -1,    65,    58,    59,    60,    -1,    62,    -1,    -1,    65
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/local/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/local/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 1:
#line 163 "control_parse.y"
{ new_command(); }
    break;
case 2:
#line 164 "control_parse.y"
{ new_command(); }
    break;
case 4:
#line 166 "control_parse.y"
{ new_command(); }
    break;
case 5:
#line 167 "control_parse.y"
{ new_command(); }
    break;
case 31:
#line 197 "control_parse.y"
{}
    break;
case 32:
#line 200 "control_parse.y"
{ yyval.element=assign_var(yyvsp[-2].var,0,yyvsp[0].express); if(yyvsp[0].express) free(yyvsp[0].express);}
    break;
case 33:
#line 201 "control_parse.y"
{ yyval.element=assign_var(yyvsp[-5].var,yyvsp[-3].express,yyvsp[0].express); if(yyvsp[-3].express) free(yyvsp[-3].express); if(yyvsp[0].express) free(yyvsp[0].express);}
    break;
case 34:
#line 204 "control_parse.y"
{ yyval.express=alloc_express(); yyval.express->type=ST_REAL; yyval.express->arg.rvalue=yyvsp[0].rvalue; }
    break;
case 35:
#line 205 "control_parse.y"
{ yyval.express=alloc_express(); yyval.express->type=ST_INTEGER; yyval.express->arg.value=yyvsp[0].value; }
    break;
case 36:
#line 206 "control_parse.y"
{ yyval.express=alloc_express(); yyval.express->type=ST_STRING; yyval.express->arg.string=yyvsp[0].string; }
    break;
case 37:
#line 207 "control_parse.y"
{ yyval.express=alloc_express(); yyval.express->type=yyvsp[0].element->type; if(yyvsp[0].element->type==ST_STRING) yyval.express->arg.string=string_copy(0,yyvsp[0].element->arg.string);
		  else yyval.express->arg=yyvsp[0].element->arg; }
    break;
case 38:
#line 209 "control_parse.y"
{ yyval.express=do_express_op(yyvsp[-2].express,yyvsp[0].express,'+'); }
    break;
case 39:
#line 210 "control_parse.y"
{ yyval.express=do_express_op(yyvsp[-2].express,yyvsp[0].express,'-'); }
    break;
case 40:
#line 211 "control_parse.y"
{ yyval.express=do_express_op(yyvsp[-2].express,yyvsp[0].express,'*'); }
    break;
case 41:
#line 212 "control_parse.y"
{ yyval.express=do_express_op(yyvsp[-2].express,yyvsp[0].express,'/'); }
    break;
case 42:
#line 213 "control_parse.y"
{ yyval.express=do_express_op(yyvsp[0].express,0,'-'); }
    break;
case 43:
#line 214 "control_parse.y"
{ yyval.express=yyvsp[-1].express; }
    break;
case 44:
#line 217 "control_parse.y"
{ syst_var[yyvsp[-1].value]=yyvsp[0].value; }
    break;
case 45:
#line 218 "control_parse.y"
{ yyerror("Unrecognized system variable"); }
    break;
case 46:
#line 221 "control_parse.y"
{ enter_loop(); }
    break;
case 47:
#line 224 "control_parse.y"
{iflag=1;}
    break;
case 48:
#line 224 "control_parse.y"
{include_control_file(yyvsp[0].string);}
    break;
case 49:
#line 227 "control_parse.y"
{ add_censored(yyvsp[-4].element,1); at_use=0;}
    break;
case 50:
#line 230 "control_parse.y"
{ add_censored(0,0); at_use=0;}
    break;
case 51:
#line 233 "control_parse.y"
{ set_sex(yyvsp[-3].element,yyvsp[-2].express,yyvsp[0].express); }
    break;
case 52:
#line 236 "control_parse.y"
{ do_while_com(yyvsp[-1].express); if(yyvsp[-1].express) free(yyvsp[-1].express);}
    break;
case 54:
#line 240 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[-2].express,yyvsp[0].express,'=');}
    break;
case 55:
#line 241 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[-2].express,yyvsp[0].express,NEQSYMBOL);}
    break;
case 56:
#line 242 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[-2].express,yyvsp[0].express,LEQSYMBOL);}
    break;
case 57:
#line 243 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[-2].express,yyvsp[0].express,GEQSYMBOL);}
    break;
case 58:
#line 244 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[-2].express,yyvsp[0].express,'<');}
    break;
case 59:
#line 245 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[-2].express,yyvsp[0].express,'>');}
    break;
case 60:
#line 246 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[-2].express,yyvsp[0].express,ORSYMBOL);}
    break;
case 61:
#line 247 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[-2].express,yyvsp[0].express,ANDSYMBOL);}
    break;
case 62:
#line 248 "control_parse.y"
{yyval.express=do_logical_op(yyvsp[0].express,0,NOTSYMBOL);}
    break;
case 63:
#line 251 "control_parse.y"
{ (void)fputc('\n',stdout); }
    break;
case 64:
#line 254 "control_parse.y"
{ print_exp(yyvsp[0].express); if(yyvsp[0].express) free(yyvsp[0].express); }
    break;
case 65:
#line 255 "control_parse.y"
{ print_exp(yyvsp[0].express); if(yyvsp[0].express) free(yyvsp[0].express); }
    break;
case 66:
#line 258 "control_parse.y"
{if(rsformat) free(rsformat); rsformat=yyvsp[0].string;}
    break;
case 67:
#line 259 "control_parse.y"
{if(fsformat) free(fsformat); fsformat=yyvsp[0].string;}
    break;
case 68:
#line 260 "control_parse.y"
{if(gsformat) free(gsformat); gsformat=yyvsp[0].string;}
    break;
case 69:
#line 261 "control_parse.y"
{file_skip=yyvsp[0].value;}
    break;
case 71:
#line 266 "control_parse.y"
{set_array_var(yyvsp[-3].var->data,yyvsp[-1].express); if(yyvsp[-1].express) free(yyvsp[-1].express); }
    break;
case 72:
#line 267 "control_parse.y"
{set_array_var(yyvsp[-3].var->data,yyvsp[-1].express); if(yyvsp[-1].express) free(yyvsp[-1].express); }
    break;
case 73:
#line 270 "control_parse.y"
{add_restriction(yyvsp[-4].var_list);at_use=0;}
    break;
case 74:
#line 271 "control_parse.y"
{add_restriction(0);at_use=0;}
    break;
case 75:
#line 274 "control_parse.y"
{add_restriction(yyvsp[0].var_list);at_use=0;}
    break;
case 76:
#line 275 "control_parse.y"
{add_restriction(0);at_use=0;}
    break;
case 77:
#line 278 "control_parse.y"
{add_operation(&(yyvsp[0].value),INTEGER,0);}
    break;
case 78:
#line 279 "control_parse.y"
{add_operation(&(yyvsp[0].rvalue),REAL,0);}
    break;
case 79:
#line 280 "control_parse.y"
{add_operation(yyvsp[0].string,STRING,0);}
    break;
case 80:
#line 281 "control_parse.y"
{if(yyvsp[0].element) check_element_add_op(yyvsp[0].element);}
    break;
case 81:
#line 282 "control_parse.y"
{add_operation(0,0,'+');}
    break;
case 82:
#line 283 "control_parse.y"
{add_operation(0,0,'-');}
    break;
case 83:
#line 284 "control_parse.y"
{add_operation(0,0,'*');}
    break;
case 84:
#line 285 "control_parse.y"
{add_operation(0,0,'/');}
    break;
case 86:
#line 287 "control_parse.y"
{add_operation(0,0,UMINUS);}
    break;
case 87:
#line 288 "control_parse.y"
{add_operation(0,0,'=');}
    break;
case 88:
#line 289 "control_parse.y"
{add_operation(0,0,NEQSYMBOL);}
    break;
case 89:
#line 290 "control_parse.y"
{add_operation(0,0,LEQSYMBOL);}
    break;
case 90:
#line 291 "control_parse.y"
{add_operation(0,0,GEQSYMBOL);}
    break;
case 91:
#line 292 "control_parse.y"
{add_operation(0,0,'<');}
    break;
case 92:
#line 293 "control_parse.y"
{add_operation(0,0,'>');}
    break;
case 93:
#line 294 "control_parse.y"
{add_operation(0,0,ORSYMBOL);}
    break;
case 94:
#line 295 "control_parse.y"
{add_operation(0,0,ANDSYMBOL);}
    break;
case 95:
#line 296 "control_parse.y"
{add_operation(0,0,NOTSYMBOL);}
    break;
case 96:
#line 299 "control_parse.y"
{ do_file_com(yyvsp[-2].string,0,0,yyvsp[0].var_list); }
    break;
case 97:
#line 300 "control_parse.y"
{ do_file_com(yyvsp[-2].string,yyvsp[-4].format_clause,0,yyvsp[0].var_list); }
    break;
case 98:
#line 301 "control_parse.y"
{ do_file_com(yyvsp[-2].string,0,yyvsp[-4].fformat,yyvsp[0].var_list); }
    break;
case 99:
#line 304 "control_parse.y"
{ yyval.string=yyvsp[0].string; }
    break;
case 100:
#line 305 "control_parse.y"
{ yyval.string=yyvsp[-1].string; shell_flag=1; }
    break;
case 101:
#line 308 "control_parse.y"
{yyval.format_clause=add_f_atom(0,yyvsp[0].f_atom); }
    break;
case 102:
#line 309 "control_parse.y"
{yyval.format_clause=add_f_atom(yyvsp[-2].format_clause,yyvsp[0].f_atom); }
    break;
case 103:
#line 310 "control_parse.y"
{yyval.format_clause=add_f_list(0,yyvsp[-1].format_clause,yyvsp[-3].value); }
    break;
case 104:
#line 311 "control_parse.y"
{yyval.format_clause=add_f_list(yyvsp[-5].format_clause,yyvsp[-1].format_clause,yyvsp[-3].value); }
    break;
case 106:
#line 315 "control_parse.y"
{yyval.fformat=add_fformat(yyvsp[-2].fformat,yyvsp[0].fformat); }
    break;
case 107:
#line 316 "control_parse.y"
{yyval.fformat=add_fformat(yyvsp[-2].fformat,yyvsp[0].fformat); }
    break;
case 108:
#line 319 "control_parse.y"
{yyval.fformat=create_fformat(yyvsp[0].string,2); }
    break;
case 109:
#line 320 "control_parse.y"
{yyval.fformat=create_fformat(yyvsp[0].string,1); }
    break;
case 110:
#line 321 "control_parse.y"
{yyval.fformat=create_fformat(yyvsp[0].string,4); }
    break;
case 111:
#line 322 "control_parse.y"
{yyval.fformat=create_fformat(&yyvsp[0].value,3); }
    break;
case 112:
#line 325 "control_parse.y"
{yyval.f_atom=make_f_atom(yyvsp[0].value,0);}
    break;
case 113:
#line 326 "control_parse.y"
{yyval.f_atom=make_f_atom(yyvsp[-1].value,1);}
    break;
case 114:
#line 327 "control_parse.y"
{yyval.f_atom=make_f_atom(1,1);}
    break;
case 115:
#line 328 "control_parse.y"
{yyval.f_atom=make_f_atom(0,1); scan_error|=FORMAT_ERR; }
    break;
case 116:
#line 329 "control_parse.y"
{yyval.f_atom=make_f_atom(0,1); scan_error|=FORMAT_ERR; }
    break;
case 117:
#line 333 "control_parse.y"
{ if(LogFile) free(LogFile); LogFile=yyvsp[0].string; }
    break;
case 118:
#line 336 "control_parse.y"
{ if(OutputFile) free(OutputFile); OutputFile=yyvsp[0].string; }
    break;
case 119:
#line 337 "control_parse.y"
{ if(OutputLaurFile) free(OutputLaurFile); OutputLaurFile=yyvsp[0].string; }
    break;
case 120:
#line 338 "control_parse.y"
{ if(OutputRawFile) free(OutputRawFile); OutputRawFile=yyvsp[0].string; }
    break;
case 121:
#line 342 "control_parse.y"
{ if(ErrorDir) free(ErrorDir); ErrorDir=yyvsp[0].string;}
    break;
case 122:
#line 345 "control_parse.y"
{ do_missing_com(yyvsp[0].string,0,0); }
    break;
case 123:
#line 346 "control_parse.y"
{ do_missing_com(yyvsp[-1].string,yyvsp[0].var_list,0); }
    break;
case 124:
#line 347 "control_parse.y"
{ do_missing_com(yyvsp[-2].string,yyvsp[0].var_list,0); }
    break;
case 125:
#line 348 "control_parse.y"
{ do_missing_com(yyvsp[0].string,0,yyvsp[-2].string); }
    break;
case 126:
#line 351 "control_parse.y"
{ do_ped_com(yyvsp[0].var_list); }
    break;
case 128:
#line 355 "control_parse.y"
{ change_type(ST_TRAITLOCUS,yyvsp[0].var_list); free_vlist(yyvsp[0].var_list);}
    break;
case 129:
#line 358 "control_parse.y"
{ change_type(ST_CONSTANT,yyvsp[0].var_list); free_vlist(yyvsp[0].var_list);}
    break;
case 130:
#line 359 "control_parse.y"
{ change_type(ST_MULTIPLE,yyvsp[0].var_list); free_vlist(yyvsp[0].var_list);}
    break;
case 131:
#line 360 "control_parse.y"
{ change_type(ST_RANDOM|ST_FACTOR,yyvsp[0].var_list); free_vlist(yyvsp[0].var_list);}
    break;
case 132:
#line 361 "control_parse.y"
{ change_type(ST_FACTOR,yyvsp[0].var_list); free_vlist(yyvsp[0].var_list);}
    break;
case 133:
#line 362 "control_parse.y"
{change_type(ST_REALTYPE,yyvsp[0].var_list); free_vlist(yyvsp[0].var_list);}
    break;
case 134:
#line 363 "control_parse.y"
{change_type(ST_INTTYPE,yyvsp[0].var_list); free_vlist(yyvsp[0].var_list);}
    break;
case 135:
#line 366 "control_parse.y"
{ yyval.value=LINK_AUTO; }
    break;
case 136:
#line 367 "control_parse.y"
{ yyval.value=LINK_X; }
    break;
case 137:
#line 368 "control_parse.y"
{ yyval.value=LINK_Y; }
    break;
case 138:
#line 371 "control_parse.y"
{ do_link_com(0,yyvsp[-1].value,yyvsp[0].var_list); }
    break;
case 139:
#line 372 "control_parse.y"
{ do_link_com(yyvsp[-2].string,yyvsp[-3].value,yyvsp[0].var_list); }
    break;
case 140:
#line 373 "control_parse.y"
{ yyerror1("No variable list for LINK command\n"); }
    break;
case 141:
#line 376 "control_parse.y"
{
	if(Filter) {
	  print_scan_warn("Line %d: Warning - Filter defined twice\n",lineno);
	  free(Filter);
   }
	Filter=yyvsp[0].string; }
    break;
case 142:
#line 384 "control_parse.y"
{do_model_com(yyvsp[0].model_list,yyvsp[-2].var,0);}
    break;
case 143:
#line 385 "control_parse.y"
{do_model_com(yyvsp[0].model_list,yyvsp[-5].var,yyvsp[-3].express); if(yyvsp[-3].express) free(yyvsp[-3].express); }
    break;
case 144:
#line 388 "control_parse.y"
{set_group(yyvsp[0].element);}
    break;
case 145:
#line 391 "control_parse.y"
{ yyval.model_list=add_to_model(yyvsp[-2].model_list,yyvsp[0].var_list); }
    break;
case 146:
#line 392 "control_parse.y"
{ yyval.model_list=add_to_model(yyvsp[-2].model_list,yyvsp[0].var_list); }
    break;
case 147:
#line 393 "control_parse.y"
{ yyval.model_list=add_to_model(0,yyvsp[0].var_list); }
    break;
case 148:
#line 394 "control_parse.y"
{ yyval.model_list=add_to_model(0,yyvsp[0].var_list); }
    break;
case 149:
#line 397 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 150:
#line 398 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 151:
#line 399 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 152:
#line 400 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 153:
#line 403 "control_parse.y"
{ yyval.var_list=add_to_var_list(0,yyvsp[0].var,0); }
    break;
case 154:
#line 404 "control_parse.y"
{ yyval.var_list=add_to_var_list(0,yyvsp[0].var,0); }
    break;
case 155:
#line 405 "control_parse.y"
{ yyval.var_list=add_to_var_list(0,yyvsp[-3].var,yyvsp[-1].express); if(yyvsp[-1].express) free(yyvsp[-1].express); }
    break;
case 156:
#line 408 "control_parse.y"
{ yyval.element=get_element(yyvsp[0].var,0); }
    break;
case 157:
#line 409 "control_parse.y"
{ yyval.element=get_element(yyvsp[-3].var,yyvsp[-1].express); if(yyvsp[-1].express) free(yyvsp[-1].express); }
    break;
case 160:
#line 414 "control_parse.y"
{ if(yyvsp[-1].element) set_locus_element(yyvsp[-1].element); }
    break;
case 161:
#line 415 "control_parse.y"
{ if(yyvsp[0].element) set_locus_element(yyvsp[0].element); }
    break;
case 162:
#line 418 "control_parse.y"
{ if(yyvsp[-1].element) set_haplo_element(yyvsp[-1].element,0); }
    break;
case 163:
#line 419 "control_parse.y"
{ if(yyvsp[-3].element) set_haplo_element(yyvsp[-3].element,yyvsp[-1].element); }
    break;
case 166:
#line 424 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 167:
#line 427 "control_parse.y"
{ start_loopclause(); }
    break;
case 168:
#line 430 "control_parse.y"
{ free_vlist(yyvsp[-6].var_list); begin_looping(yyvsp[-3].element,yyvsp[-1].express,0); }
    break;
case 169:
#line 431 "control_parse.y"
{ free_vlist(yyvsp[-8].var_list); begin_looping(yyvsp[-5].element,yyvsp[-3].express,yyvsp[-1].express); }
    break;
case 170:
#line 434 "control_parse.y"
{ yyval.var_list=yyvsp[-1].var_list; in_loopclause=0; }
    break;
case 171:
#line 435 "control_parse.y"
{ yyval.var_list=0; in_loopclause=0; }
    break;
case 172:
#line 438 "control_parse.y"
{ yyval.var_list=add_to_var_list(0,0,0); }
    break;
case 173:
#line 439 "control_parse.y"
{ yyval.var_list=add_to_var_list(0,yyvsp[0].var,0); }
    break;
case 174:
#line 440 "control_parse.y"
{ yyval.var_list=add_to_var_list(0,yyvsp[0].var,0); }
    break;
case 175:
#line 441 "control_parse.y"
{ yyval.var_list=add_to_var_list(0,yyvsp[-3].var,yyvsp[-1].express); if(yyvsp[-1].express) free(yyvsp[-1].express); }
    break;
case 178:
#line 446 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 179:
#line 447 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 182:
#line 452 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 183:
#line 453 "control_parse.y"
{ yyval.var_list=add_var_lists(yyvsp[-2].var_list,yyvsp[0].var_list); }
    break;
case 184:
#line 456 "control_parse.y"
{ yyval.string = yyvsp[0].string; }
    break;
case 185:
#line 457 "control_parse.y"
{ yyval.string = string_copy(yyvsp[-2].string,yyvsp[0].string); free(yyvsp[0].string); }
    break;
case 186:
#line 458 "control_parse.y"
{ if(yyvsp[-2].element && (yyvsp[-2].element->type&ST_STRING)) yyval.string = string_copy(yyvsp[0].string,yyvsp[-2].element->arg.string); else yyval.string=yyvsp[0].string; }
    break;
case 187:
#line 461 "control_parse.y"
{ yyval.string = yyvsp[0].string; }
    break;
case 188:
#line 462 "control_parse.y"
{ if(yyvsp[0].element && (yyvsp[0].element->type&ST_STRING)) yyval.string = string_copy(0,yyvsp[0].element->arg.string); else yyval.string=0; }
    break;
case 189:
#line 463 "control_parse.y"
{ yyval.string = string_copy(yyvsp[-2].string,yyvsp[0].string); free(yyvsp[0].string); }
    break;
case 190:
#line 464 "control_parse.y"
{ if(yyvsp[0].element && (yyvsp[0].element->type&ST_STRING)) yyval.string = string_copy(yyvsp[-2].string,yyvsp[0].element->arg.string); else yyval.string=yyvsp[-2].string; }
    break;
}

#line 705 "/usr/local/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 466 "control_parse.y"


static void enter_loop(void)
{	
	if(loop_level<MAX_LOOP)	{
		loop_stat[loop_level]=loop_record;
		loop_ptr[loop_level]=loop_main_ptr;
		loop_level++;
		if(!loop_record) loop_record=1;
	} else yyerror("Too many nested loops\n");
}

static void start_loopclause(void)
{	
	if(loop_level<MAX_LOOP)	{
		loop_stat[loop_level]=loop_record;
		loop_ptr[loop_level]=loop_main_ptr;
		in_loopclause=1;
		loop_level++;
		if(!loop_record) loop_record=1;
	} else yyerror("Too many nested loops\n");
}

static void begin_looping(struct var_element *element, struct express *exp1, struct express *exp2)
{	
	int er=0,i;
	
	if(element && exp1) {
		if(exp1->type==ST_INTEGER) loop_clause_end=(int)exp1->arg.value;
		else er=1;
		if(!er && exp2) {
			if(exp2->type==ST_INTEGER) loop_clause_step=(int)exp2->arg.value;
			else er=1;
		} else loop_clause_step=1;
		if(element->type&ST_INTEGER) {
			i=(int)element->arg.value;
			if(loop_clause_step<0) {
				if(i<loop_clause_end) er= -1;
			} else if(i>loop_clause_end) er= -1;
		} else er=1;
	} else er=2;
	if(er) {
		switch(er) {
		 case 1:
			yyerror("Loop variable not integer type\n");
			break;
		 case 2:
			yyerror("Syntax error\n");
			break;
		}
		loop_record=loop_stat[--loop_level];
		if(!loop_record) loop_main_ptr=loop_level?loop_ptr[loop_level-1]:0;
		in_loopclause=0;
	} else {
		in_loopclause= -1;
		loop_record= -1;
		loop_clause_ptr=loop_main_ptr;
		loop_clause_element=element;
		loop_main_ptr=loop_ptr[loop_level-1];
	}
	if(exp1) free(exp1);
	if(exp2) free(exp2);
}

static int if_true(struct express *express)
{
	int l=0;
	
	if(express)	{
		switch(express->type) {
		 case ST_INTEGER:
			l=(express->arg.value!=0);
			break;
		 case ST_REAL:
			l=(express->arg.rvalue!=0.0);
			break;
		 case ST_STRING:
			if(express->arg.string && express->arg.string[0]) l=1;
		}
	}
	return l;
}

static void do_while_com(struct express *express)
{
	int i;
	
	if(loop_level)	{
		if(!scan_error_n && if_true(express)) {
			loop_record= -1;
			loop_main_ptr=loop_ptr[loop_level-1];
		} else {
			loop_record=loop_stat[--loop_level];
			if(!loop_record) {
				i=loop_main_ptr-1;
				loop_main_ptr=loop_level?loop_ptr[loop_level-1]:0;
				for(;i>=loop_main_ptr;i--)	{
					if(loop_stack[i].token==STRING) free(loop_stack[i].yylval.string);
				}
			}
		}
	} else yyerror("WHILE outside of do loop\n");
}

static void print_exp(struct express *express)
{
	if(!express) return;
	switch(express->type) {
	 case ST_STRING:
		(void)fputs(express->arg.string,stdout);
		free(express->arg.string);
		break;
	 case ST_INTEGER:
		(void)printf("%ld",express->arg.value);
		break;
	 case ST_REAL:
		(void)printf("%g",express->arg.rvalue);
		break;
	}
}

static void set_sex(struct var_element *elem,struct express *exp1,struct express *exp2)
{
	if(!exp1 || !exp2) yyerror1("Null arguments to sex command\n");
	else if(sex_elem) yyerror1("Error: Multiple sex commands");
	else {
		if(exp1->type != exp2->type) yyerror1("Arguments to sex command of different type\n");
		else if(exp1->type!=ST_INTEGER && exp1->type!=ST_STRING) yyerror1("Arguments to sex command of invalid type\n");
		else {
			sex_elem=elem;
			sex_exp[0]=exp1;
			sex_exp[1]=exp2;
			sex_elem->type|=(ST_SEX|ST_FACTOR|ST_CONSTANT);
			if(exp1->type==ST_INTEGER) sex_elem->type|=ST_INTTYPE;
		}
	}
}

static void set_group(struct var_element *elem)
{
	if(group_elem) yyerror1("Error: Multiple group commands");
	else {
		group_elem=elem;
		group_elem->type|=(ST_GROUP|ST_FACTOR|ST_CONSTANT);
	}
}

static void do_ped_com(struct var_list *vlist)
{
	int i,j,n;
	struct var_list *vlist1;
	struct scan_data *sd;
	
	if(pedflag) {
		yyerror1("Error: Multiple pedigree commands");
		scan_error|=PED_ERR;
	}
	pedflag=1;
	n=0;
	while(vlist) {
		sd=vlist->var->data;
		if(sd->vtype&ST_ARRAY) {
			if(vlist->index) {
				if(n<4) pedlist[n]=sd->element+vlist->index-1;
				n++;
			} else for(i=0;i<sd->n_elements;i++)	{
				if(n<4) pedlist[n]=sd->element+i;
				n++;
			}
		} else {
			if(n<4) pedlist[n]=sd->element;
			n++;
		}
		vlist1=vlist->next;
		free(vlist);
		vlist=vlist1;
	}
	if(n!=3 && n!=4) {
		yyerror1("Error: Wrong no. variables for pedigree command (3 or 4 required)");
		scan_error|=PED_ERR;
	} else {
		for(i=1;i<n;i++) {
			for(j=0;j<i;j++) if(pedlist[i]==pedlist[j]) {
				yyerror1("Error: Repeated variables in pedigree command");
				scan_error|=PED_ERR;
			}
		}
		if(n==4) {
			pedlist[0]->type|=(ST_FAMILY|ST_FACTOR|ST_CONSTANT);
			family_id=1;
			i=1;
		} else i=0;
		pedlist[i++]->type|=(ST_ID|ST_FACTOR|ST_CONSTANT);
		pedlist[i++]->type|=(ST_SIRE|ST_FACTOR|ST_CONSTANT);
		pedlist[i++]->type|=(ST_DAM|ST_FACTOR|ST_CONSTANT);
	}
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "alloc_express"
static struct express *alloc_express(void)
{
	struct express *e;
	
	if(!(e=malloc(sizeof(struct express)))) ABT_FUNC(MMsg);
	return e;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "do_logical_op"
static struct express *do_logical_op(struct express *ex1,struct express *ex2,int op)
{
	int i=0,l=0;
	double rv1,rv2;
	char *s1,*s2;
	
	s1=s2=0;
	if(ex1->type&ST_STRING) {
		s1=ex1->arg.string;
		i++;
	}
	if(ex2 && ex2->type&ST_STRING) {
		s2=ex2->arg.string;
		i++;
	}
	if(i==2)	{
		switch(op) {
		 case '=':
			l=mystrcmp(s1,s2)?0:1;
			break;
		 case NEQSYMBOL:
			l=mystrcmp(s1,s2)?1:0;
			break;
		 case '<':
			l=mystrcmp(s1,s2)<0?1:0;
			break;
		 case '>':
			l=mystrcmp(s1,s2)>0?1:0;
			break;
		 case LEQSYMBOL:
			l=mystrcmp(s1,s2)>=0?1:0;
			break;
		 case GEQSYMBOL:
			l=mystrcmp(s1,s2)>=0?1:0;
			break;
		 case ORSYMBOL:
			l=(s1 || s2);
			break;
		 case ANDSYMBOL:
			l=(s1 && s2);
			break;
		 default:
			ABT_FUNC("Internal error - invalid string op\n");
		}
	} else if(i && !ex2)	{
		if(op!=NOTSYMBOL) ABT_FUNC("Internal error - invalid unary string op\n");
		else l=s1?0:1;
	} else if(i) {
		switch(op) {
		 case ORSYMBOL:
			if(ex1->type&ST_STRING) l=(s1 || ex2->arg.value);
			else l=(s2 || ex1->arg.value);
			break;
		 case ANDSYMBOL:
			if(ex1->type&ST_STRING) l=(s1 && ex2->arg.value);
			else l=(s2 && ex1->arg.value);
			break;
		 default:
			ABT_FUNC("Internal error - invalid string op\n");
		}
	} else {
		rv1=rv2=0.0;
		if(ex1->type&ST_INTEGER) rv1=(double)ex1->arg.value;
		else if(ex1->type&ST_REAL) rv1=ex1->arg.rvalue;
		if(ex2) {
			if(ex2->type&ST_INTEGER) rv2=(double)ex2->arg.value;
			else if(ex2->type&ST_REAL) rv2=ex2->arg.rvalue;
		}
		switch(op) {
		 case '=':
			l=(rv1==rv2);
			break;
		 case NEQSYMBOL:
			l=(rv1!=rv2);
			break;
		 case '<':
			l=(rv1<rv2);
			break;
		 case '>':
			l=(rv1>rv2);
			break;
		 case LEQSYMBOL:
			l=(rv1<=rv2);
			break;
		 case GEQSYMBOL:
			l=(rv1>=rv2);
			break;
		 case ORSYMBOL:
			l=(rv1 || rv2);
			break;
		 case ANDSYMBOL:
			l=(rv1 && rv2);
			break;
		 case NOTSYMBOL:
			l=(rv1==0.0);
			break;
		 default:
			ABT_FUNC("Internal error - invalid op\n");
		}
	}
	if(ex2) free(ex2);
	ex1->type=ST_INTEGER;
	ex1->arg.value=l;
	return ex1;
}

static struct express *do_express_op(struct express *ex1,struct express *ex2,int op)
{
	double rv1,rv2;
	int i;
	
	if(ex1->type&ST_STRING)	{
		if(ex2 && ex2->type&ST_STRING) {
			if(op!='+') yyerror("Illegal string operation\n");
			else {
				ex1->arg.string=string_copy(ex1->arg.string,ex2->arg.string);
				free(ex2->arg.string);
			}
		} else yyerror("Can't mix numeric and string expressions\n");
	} else if(ex2 && ex2->type&ST_STRING) yyerror("Can't mix numeric and string expressions\n");
	else {
		rv1=rv2=0.0;
		if(ex1->type&ST_INTEGER) rv1=(double)ex1->arg.value;
		else if(ex1->type&ST_REAL) rv1=ex1->arg.rvalue;
		if(ex2) {
			if(ex2->type&ST_INTEGER) rv2=(double)ex2->arg.value;
			else if(ex2->type&ST_REAL) rv2=ex2->arg.rvalue;
		}
		switch(op) {
		 case '+': 
			rv1+=rv2;
			break;
		 case '-':
			if(ex2) rv1-=rv2;
			else rv1= -rv1;
			break;
		 case '*':
			rv1*=rv2;
			break;
		 case '/':
			if(rv2==0.0) {
				yyerror("Divide by zero error\n");
				rv1=0.0;
			} else rv1/=rv2;
			break;
		}
		i=(int)rv1;
		if((double)i==rv1) {
			ex1->type=ST_INTEGER;
			ex1->arg.value=i;
		} else {
			ex1->type=ST_REAL;
			ex1->arg.rvalue=rv1;
		}
	}
	if(ex2) free(ex2);
	return ex1;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "check_element_add_op"
static void check_element_add_op(struct var_element *element)
{
	switch(element->type&(ST_REAL|ST_INTEGER|ST_STRING)) {
	 case ST_STRING:
		add_operation(string_copy(0,element->arg.string),STRING,0);
		break;
	 case ST_INTEGER:
		add_operation(&element->arg,INTEGER,0);
		break;
	 case ST_REAL:
		add_operation(&element->arg,REAL,0);
		break;
	 case 0:
		add_operation(element,VARIABLE,0);
		break;
	 default:
		ABT_FUNC("Internal error - illegal element type\n");
	}
}

static int check_index(struct scan_data *sd,struct express *express)
{
	int i;

	if(express->type!=ST_INTEGER) {
		if(in_loopclause<=0) yyerror("Non-integral expression for array index");
	} else if(sd->vtype&ST_ARRAY) {
		i=(int)express->arg.value;
		if(i<1 || i>sd->n_elements) {
			if(in_loopclause<=0) yyerror("Array index out of bounds");
		} else return i;
	} else	yyerror("Not an array");
	return 0;
}

static struct var_element *get_element(struct bin_node *node,struct express *express)
{
	int i;
	struct scan_data *sd;
	
	sd=node->data;
	if(express) {
		if(!(i=check_index(sd,express))) return 0;
		return sd->element+i-1;
	} else {
		if(sd->vtype&ST_ARRAY)	{
			yyerror("Illegal reference to array");
			return 0;
		}
	}
	return sd->element;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "set_array_var"
static void set_array_var(struct scan_data *sd,struct express *express)
{
	int i;

	if(express->type!=ST_INTEGER) yyerror("Non-integral expression for array size");
	else if((i=(int)express->arg.value)<1) yyerror("Illegal array size");
	else if(sd->vtype) yyerror("Can't redefine variable");
	else {
		sd->vtype|=ST_ARRAY;
		sd->n_elements=i;
		free(sd->element);
		if(!(sd->element=calloc((size_t)sd->n_elements,sizeof(struct var_element)))) ABT_FUNC(MMsg);
	}
}

static int count_var_list(struct var_list *vlist)
{
	int i=0;
	struct scan_data *sd=0;
	
	while(vlist) {
		if(vlist->var) sd=vlist->var->data;
		if(sd && (sd->vtype&ST_ARRAY) && !vlist->index) i+=sd->n_elements;
		else i++;
		vlist=vlist->next;
	}
	return i;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "assign_var"
static struct var_element *assign_var(struct bin_node *node,struct express *ix,struct express *express)
{
	struct var_element *element;
	struct scan_data *sd;
	
	if(!express) return 0;
	if(!(element=get_element(node,ix))) return 0;
	switch(express->type) {
	 case ST_STRING:
	     element->arg.string=express->arg.string;
		RemBlock=AddRemem(element->arg.string,RemBlock);
		break;
	 case ST_REAL:
	 case ST_INTEGER:
	     element->arg=express->arg;
		break;
	 case 0:
	     yyerror1("Undefined assignment\n");
		element->type=0;
		element->arg.string=0;
		break;
	 default:
		ABT_FUNC(IntErr);
	}
	if(!ix) {
		sd=node->data;
		sd->vtype|=ST_SCALAR;
	}
	element->type=express->type;
	return element;
}

void check_vars(struct bin_node *node,int *i,void check_func(struct bin_node *,int *))
{
	if(node->left) {
		check_vars(node->left,i,check_func);
	}
	check_func(node,i);
	if(node->right) {
		check_vars(node->right,i,check_func);
	}
}

static void check_vars_1(struct bin_node *node,void check_func(struct bin_node *))
{
	if(node->left) {
		check_vars_1(node->left,check_func);
	}
	check_func(node);
	if(node->right) {
		check_vars_1(node->right,check_func);
	}
}

void print_scan_err(char *fmt, ...)
{
	va_list args;
	
	va_start(args,fmt);
	(void)vfprintf(stderr,fmt,args);
	va_end(args);
	if((++scan_error_n)>=max_scan_errors) abt(__FILE__,__LINE__,"Too many errors - aborting\n");
}

void print_scan_warn(char *fmt, ...)
{
	va_list args;
	
	if(scan_warn_n<max_scan_warnings) {
		va_start(args,fmt);
		(void)vfprintf(stderr,fmt,args);
		va_end(args);
	}
	scan_warn_n++;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "add_operation"
static void add_operation(void *arg,int type, int op)
{
	struct operation *o;
	
	if(!arg && type) ABT_FUNC(IntErr);
	if(!(o=malloc(sizeof(struct operation)))) ABT_FUNC(MMsg);
	o->next=Op_List;
	Op_List=o;
	o->type=type;
	o->op=op;
	switch(type) {
	 case VARIABLE:
		o->arg.element= (struct var_element *)arg;
		break;
	 case INTEGER:
		o->arg.value= *(int *)arg;
		break;
	 case REAL:
		o->arg.rvalue= *(double *)arg;
		break;
	 case STRING:
		o->arg.string= (char *)arg;
		break;
	}
}

static void new_command(void)
{
	shell_flag=in_loopclause=0;
	Op_List=0;
	iflag=0;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "add_to_model"
static struct model_list *add_to_model(struct model_list *model,struct var_list *vlist)
{
	struct var_list *vlist1;
	struct scan_data *sd;
	struct model_list *m1;
	int i;
	
	if(!(m1=malloc(sizeof(struct model_list)))) ABT_FUNC(MMsg);
	if(vlist) {
		i=count_var_list(vlist);
		if(!(m1->element=malloc(sizeof(void *)*i))) ABT_FUNC(MMsg);
		i=0;
		while(vlist) {
			sd=vlist->var->data;
			if(sd->vtype&ST_ARRAY)	{
				if(vlist->index) {
					sd->element[vlist->index-1].type|=ST_MODEL;
					sd->element[vlist->index-1].index=vlist->index;
					sd->element[vlist->index-1].oindex=vlist->index;
					m1->element[i++]=sd->element+vlist->index-1;
				} else yyerror("Error - Can't use whole arrays as model parameters");
			} else {
				sd->element[0].type|=ST_MODEL;
				sd->element[0].index=0;
				m1->element[i++]=sd->element;
			}
			vlist1=vlist->next;
			free(vlist);
			vlist=vlist1;
		}
		m1->nvar=i;
	} else ABT_FUNC("Nothing to add...\n");
	m1->next=model;
	return m1;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "string_copy"
static char *string_copy(char *s1,char *s2)
{
	if(s1) {  
		if(!(s1=realloc(s1,strlen(s1)+strlen(s2)+1))) ABT_FUNC(MMsg);
		(void)strcat(s1,s2);
	} else {
		if(!(s1=malloc(strlen(s2)+1))) ABT_FUNC(MMsg);
		(void)strcpy(s1,s2);
	}
	return s1;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "setup_format"
static struct format *setup_format(struct format_clause *fc)
{
	int i,n=0,pp=0;
	struct format_atom **fa;
	struct format *format;
	
	fa=fc->f_atoms;
	for(i=0;i<fc->n_atoms;i++) if(!fa[i]->pos) n++;
	if(!n) {
		if(!(scan_error&FORMAT_ERR)) yyerror("Error - Empty format clause");
		free(fa);
		free(fc);
		scan_error|=FORMAT_ERR;
		scan_error_n++;
		return 0;
	}
	if(!(format=malloc(sizeof(struct format)))) ABT_FUNC(MMsg);
	format->line=lineno;
	if(!(format->f_atoms=malloc(sizeof(struct format_atom)*n))) ABT_FUNC(MMsg);
	for(i=n=0;i<fc->n_atoms;i++) {
		if(!fa[i]->pos) {
			format->f_atoms[n].size=fa[i]->size;
			format->f_atoms[n++].pos=pp;
		}
		pp+=fa[i]->size;
	}
	free(fa);
	format->n_atoms=n;
	f_atom_n=0;
	free(fc);
	return format;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "make_f_atom"
static struct format_atom *make_f_atom(int n,int flag)
{
	if(f_atom_n>=f_atom_size) {
		f_atom_size*=2;
		if(!(f_atom_list=realloc(f_atom_list,sizeof(struct format_atom)*f_atom_size))) ABT_FUNC(MMsg);
	}
	f_atom_list[f_atom_n].size=n;
	f_atom_list[f_atom_n].pos=flag;
	return &f_atom_list[f_atom_n++];
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "add_fformat"
static struct fformat *add_fformat(struct fformat *f1,struct fformat *f2)
{
	if(f2->rs) {
		if(f1->rs) free(f1->rs);
		f1->rs=f2->rs;
	}
	if(f2->fs) {
		if(f1->fs) free(f1->fs);
		f1->fs=f2->fs;
	}
	if(f2->gs) {
		if(f1->gs) free(f1->gs);
		f1->gs=f2->gs;
	}	
	if(f2->skip) f1->skip=f2->skip;
	free(f2);
	return f1;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "create_fformat"
static struct fformat *create_fformat(void *p,int fg)
{
	struct fformat *ff;
	int *i;
	
	if(!(ff=malloc(sizeof(struct fformat)))) ABT_FUNC(MMsg);
	ff->rs=ff->fs=ff->gs=0;
	ff->skip=0;
	switch(fg) {
	 case 1:
		ff->rs=p;
		break;
	 case 2:
		ff->fs=p;
		break;
	 case 3:
		i=p;
		ff->skip=*i;
		break;
	 case 4:
		ff->gs=p;
		break;
	 default:
		ABT_FUNC("Internal error - incorrect flag\n");
	}
	return ff;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "add_f_atom"
static struct format_clause *add_f_atom(struct format_clause *fc,struct format_atom *fa)
{
	if(!fc) {
		if(!(fc=malloc(sizeof(struct format_clause)))) ABT_FUNC(MMsg);
		fc->fc_size=16;
		fc->n_atoms=0;
		if(!(fc->f_atoms=malloc(sizeof(struct format_atom *)*fc->fc_size))) ABT_FUNC(MMsg);
	}
	if(fc->n_atoms>=fc->fc_size) {
		fc->fc_size*=2;
		if(!(fc->f_atoms=realloc(fc->f_atoms,sizeof(struct format_atom *)*fc->fc_size))) ABT_FUNC(MMsg);
	}
	fc->f_atoms[fc->n_atoms++]=fa;
	return fc;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "add_f_list"
static struct format_clause *add_f_list(struct format_clause *fc,struct format_clause *fc1,int n)
{
	int sz,i,j;
	
	sz=fc1->n_atoms*n;
	if(!fc) {
		if(!(fc=malloc(sizeof(struct format_clause)))) ABT_FUNC(MMsg);
		fc->fc_size=16;
		if(sz>16) fc->fc_size=sz;
		fc->n_atoms=0;
		if(!(fc->f_atoms=malloc(sizeof(struct format_atom *)*fc->fc_size))) ABT_FUNC(MMsg);
	} else {
		if(sz>(fc->fc_size-fc->n_atoms)) {
			fc->fc_size=sz+fc->n_atoms;
			if(!(fc->f_atoms=realloc(fc->f_atoms,sizeof(struct format_atom *)*fc->fc_size))) ABT_FUNC(MMsg);
		}
	}
	for(i=0;i<n;i++) for(j=0;j<fc1->n_atoms;j++)
	  fc->f_atoms[fc->n_atoms++]=fc1->f_atoms[j];
	free(fc1->f_atoms);
	free(fc1);
	return fc;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "alloc_var"
static struct bin_node *alloc_var(char *p)
{
	struct bin_node *node;
	struct scan_data *sd;
	int i;
	
	if(!(node=malloc(sizeof(struct bin_node)))) ABT_FUNC(MMsg);
	node->left=node->right=0;
	node->balance=0;
	if(!(sd=malloc(sizeof(struct scan_data)))) ABT_FUNC(MMsg);
	node->data=sd;
	sd->vtype=0;
	i=(int)strlen(p);
	if(!(sd->name=malloc((size_t)i+1))) ABT_FUNC(MMsg);
	sd->name[i--]=0;
	for(;i>=0;i--) sd->name[i]=toupper((int)p[i]);
	sd->n_elements=1;
	if(!(sd->element=calloc(1,sizeof(struct var_element)))) ABT_FUNC(MMsg);
	sd->element->arg.element=0;
	return node;
}

static struct bin_node *find_var(char *p,struct bin_node *node,struct bin_node **node1,int *balanced)
{
	int i;
	struct scan_data *sd;
	
	sd=node->data;
	if((i=strcasecmp(p,sd->name))) {
		if(i<0) {
			if(node->left) {
				node->left=find_var(p,node->left,node1,balanced);
			} else {
				*node1=node->left=alloc_var(p);
				*balanced=0;
			}
			if(!(*balanced)) {
				switch(node->balance) {
				 case -1:
					node=rotate_left(node);
					*balanced=1;
					break;
				 case 0:
					node->balance=-1;
					break;
				 case 1:
					node->balance=0;
					*balanced=1;
				}
			}
		} else {
			if(node->right) {
				node->right=find_var(p,node->right,node1,balanced);
			} else {
				*node1=node->right=alloc_var(p);
				*balanced=0;
			}
			if(!(*balanced)) {
				switch(node->balance) {
				 case -1:
					node->balance=0;
					*balanced=1;
					break;
				 case 0:
					node->balance=1;
					break;
				 case 1:
					node=rotate_right(node);
					*balanced=1;
				}
			}
		}
	} else {
		*node1=node;
		*balanced=1;
	}
	return node;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "Check_var"
static void Check_var(struct bin_node *node)
{
	int i;
	struct var_element *element;
	struct scan_data *sd;
	char *nbuf;
	
	if(node->left) Check_var(node->left);
	sd=node->data;
	i=strlen(sd->name)+4+log((double)(sd->n_elements+1))/log(10.0);
	if(!(nbuf=malloc((size_t)i))) ABT_FUNC(MMsg);
	for(i=0;i<sd->n_elements;i++) {
		if(sd->vtype&ST_ARRAY) (void)sprintf(nbuf,"%s(%d)",sd->name,i+1);
		else (void)strcpy(nbuf,sd->name);
		element=sd->element+i;
		if(!(element->type&(ST_DATA|ST_TRAITLOCUS|ST_LINKED))) {
			if(element->type&(ST_MODEL|ST_SEX|ST_ID|ST_FAMILY|ST_SIRE|ST_DAM|ST_TRAIT|ST_GROUP))
			  print_scan_err("Error: No data for variable %s\n",nbuf);
		}
		if((element->type&ST_DATA) && (element->type&ST_TRAITLOCUS))
		  print_scan_err("Error: Variable %s can not have data\n",nbuf);
		else if((element->type&ST_LINKED) && !(element->type&(ST_TRAITLOCUS|ST_MARKER)))
		  print_scan_err("Error: Variable %s is not a locus and so can not be linked\n",nbuf);
		else if((element->type&ST_TRAIT) && (element->type&(ST_GROUP|ST_MARKER|ST_TRAITLOCUS|ST_ID|ST_FAMILY|ST_SIRE|ST_DAM|ST_HAPLO|ST_LINKED|ST_STRING|ST_REAL|ST_INTEGER)))
		  print_scan_err("Error: Variable %s inappropriate type for trait\n",nbuf);
		else if((element->type&ST_TRAITLOCUS) && (element->type&(ST_SEX|ST_GROUP|ST_CENSORED|ST_RANDOM|ST_MARKER|ST_ID|ST_FAMILY|ST_SIRE|ST_DAM|ST_HAPLO|ST_STRING|ST_REAL|ST_INTEGER|ST_REALTYPE|ST_INTTYPE)))
		  print_scan_err("Error: Variable %s inappropriate type for trait locus\n",nbuf);
		else if((element->type&ST_MARKER) && (element->type&(ST_SEX|ST_GROUP|ST_CENSORED|ST_REAL|ST_INTEGER|ST_RANDOM|ST_ID|ST_FAMILY|ST_SIRE|ST_DAM|ST_HAPLO|ST_STRING|ST_INTEGER)))
		  print_scan_err("Error: Variable %s inappropriate type for marker\n",nbuf);
		else if((element->type&ST_HAPLO) && (element->type&(ST_SEX|ST_GROUP|ST_CENSORED|ST_REAL|ST_RANDOM|ST_ID|ST_FAMILY|ST_SIRE|ST_DAM|ST_STRING|ST_REAL|ST_INTEGER)))
		  print_scan_err("Error: Variable %s inappropriate type for haplotype\n",nbuf);
		else if((element->type&ST_RANDOM) && (element->type&(ST_SEX|ST_GROUP|ST_STRING|ST_REAL|ST_INTEGER|ST_REAL)))
		  print_scan_err("Error: Variable %s inappropriate type to be random\n",nbuf);
		else if((element->type&(ST_INTTYPE|ST_REALTYPE)) && (element->type&(ST_STRING|ST_REAL|ST_INTEGER)))
		  print_scan_err("Error: Type collision for variable %s\n",nbuf);
		else if((element->type&ST_INTTYPE) && (element->type&ST_REALTYPE))
		  print_scan_err("Error: Real variable %s can not also be integer type\n",nbuf);
		else if((element->type&(ST_STRING|ST_REAL|ST_INTEGER)) && (element->type&(ST_SEX|ST_ID|ST_FAMILY|ST_SIRE|ST_DAM)))
		  print_scan_err("Error: Variable %s can not be a pedigree or sex variable\n",nbuf);
		else if((element->type&ST_REAL) && (element->type&(ST_ID|ST_FAMILY|ST_SIRE|ST_DAM|ST_SEX)))
		  print_scan_err("Error: Real variable %s can not be a pedigree or sex variable\n",nbuf);
		else if((element->type&ST_FACTOR) && (element->type&ST_REAL))
		  print_scan_err("Error: Real variable %s can not be a factor\n",nbuf);
		else if((element->type&ST_CONSTANT)&&(element->type&ST_MULTIPLE))
		  print_scan_err("Error: Variable %s can not be in multiple records and be constant\n",nbuf);
		else if(element->type&(ST_SEX|ST_ID|ST_FAMILY|ST_SIRE|ST_DAM|ST_TRAITLOCUS|ST_GROUP|ST_LINKED|ST_MODEL|ST_TRAIT))
		  element->type|=ST_REQUIRED;
		else if(element->type&ST_HAPLO) {
			if(element->arg.element && element->arg.element->type&ST_LINKED) {
				element->type|=ST_REQUIRED;
				if(!(element->type&ST_DATA)) print_scan_err("Error: No data for variable %s\n",nbuf);
			}
		}
		if((element->type&(ST_MARKER|ST_REQUIRED)) == (ST_MARKER|ST_REQUIRED)) n_markers++;
		if(!(element->type&(ST_CONSTANT|ST_MULTIPLE))) 
		  element->type|=syst_var[MULTIPLE_RECORDS]?ST_MULTIPLE:ST_CONSTANT;
		if(element->type&(ST_REQUIRED|ST_RESTRICT))	{
			if(!(element->type&ST_HAPLO)) element->arg.var=node;
		} else element->type=0;
	}
	free(nbuf);
	if(node->right) Check_var(node->right);
}

static struct bin_node *create_var(char *p)
{
	int k;
	struct bin_node *node;
	
	if(!root_var) node=root_var=alloc_var(p);
	else {
		root_var=find_var(p,root_var,&node,&k);
	}
	return node;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "symbol_lookup"
int symbol_lookup(char *p,int fg)
{
	static char *Coms[] = {"FILE","LOCUS","MARKER","DISCRETE","MODEL","PEDIGREE","LOG",
		"FILTER","MISSING","MODEL","LINK","RANDOM","TRAIT","WHERE","USE",
		"REAL","INTEGER","SHELL","ARRAY","PRINT","DO","WHILE","CONSTANT",
		"MULTIPLE","CENSORED","GROUP","SET","SEX","AFFECTED","OUTPUT","INCLUDE","ERRORDIR",
		"LAUROUTPUT","RAWOUTPUT",(char *)0};
	static int Com_token[] = {FILEC,LOCUS,MARKER,FACTOR,MODEL,PEDIGREE,LOG,
		FILTER,MISSING,MODEL,LINK,RANDOM,TRAIT,WHERE,USE,
		REAL,INTEGER,SHELL,ARRAY,PRINTEXP,DOLOOP,WHILE,CONSTANT,
		MULTIPLE,CENSORED,GROUP,SET,GENDER,AFFECTED,OUTPUT,INCLUDE,ERRORDIR,
		LAUROUTPUT,RAWOUTPUT,SYSTEM_VAR,VARIABLE,ARRAY_VAR};
	static char *Syst[] = {"PRUNE_OPTION","RECODE_OPTION","NO_EXTRA_ALLELE",
		"PEEL_OPTION","TRACE_RESTRICT","TRACE_CENSORED","TRACE_AFFECTED",
		"CORRECT_ERRORS","TRACE_PEEL","MULTIPLE_RECORDS","MULTIVARIATE_TEST",
		"ERROR_CHECK","NO_DEFAULT_MISSING",(char *)0};
	int i=0,j=0;
	static struct scan_data *sd;
	
	while(Coms[i])	{
		if(!strcasecmp(Coms[i],p)) break;
		i++;
	}
	at_file=0;
	if(Com_token[i]==FILEC || Com_token[i]==LINK) at_file=1;
	if(Com_token[i]==SYSTEM_VAR) {
		i++;
		while(Syst[j])	{
			if(!strcasecmp(Syst[j],p))	{
				yylval.value=j;
				i--;
				break;
			}
			j++;
		}
	}
	if(Com_token[i]==VARIABLE) {
		if(fg && begin_comm) {
			begin_comm=0;
			return BREAK;
		}
		yylval.var=create_var(p);
		sd=yylval.var->data;
		if(sd->vtype&ST_ARRAY) i++;
		if(fg) {
			begin_comm=1;
			(void)strcpy(linebuf1,linebuf);
			lineno1=lineno;
		}
	} else if(begin_comm && Com_token[i]!=SYSTEM_VAR && Com_token[i]!=LOCUS && Com_token[i]!=SHELL
				 && !(at_use==1 && Com_token[i]==WHERE) && !(at_use==2 && Com_token[i]==USE))	{
		begin_comm=0;
		at_use=0;
		return BREAK;
	} else {
		begin_comm=1;
		(void)strcpy(linebuf1,linebuf);
		lineno1=lineno;
		if(Com_token[i]==MODEL) at_model=1;
		else at_model=0;
		if(Com_token[i]==USE || Com_token[i]==CENSORED || Com_token[i]==AFFECTED) at_use|=1;
		else if(Com_token[i]==WHERE) at_use|=2;
		else at_use=0;
	}
	return Com_token[i];
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "symbol_lookup"
static struct var_list *add_to_var_list(struct var_list *vlist,struct bin_node *node,struct express *express)
{
	struct var_list *vlist1,*vlist2;
	struct scan_data *sd=0;
	int i;

	if(node)	sd=node->data;
	if(express) i=check_index(sd,express);
	else {
		i=0;
		if(sd && !(sd->vtype&ST_ARRAY)) sd->vtype|=ST_SCALAR;
	}
	if(!(vlist1=malloc(sizeof(struct var_list)))) ABT_FUNC(MMsg);
	vlist1->next=0;
	vlist1->var=node;
	vlist1->index=i;
	vlist2=vlist;
	if(vlist2) {
		while(vlist2->next) vlist2=vlist2->next;
		vlist2->next=vlist1;
	} else vlist=vlist1;
	return vlist;
}

struct var_list *add_var_lists(struct var_list *vlist,struct var_list *vlist1)
{
	struct var_list *vlist2;
	
	vlist2=vlist;
	if(vlist2) {
		while(vlist2->next) vlist2=vlist2->next;
		vlist2->next=vlist1;
	} else vlist=vlist1;
	return vlist;
}

static void set_locus_element(struct var_element *element)
{
	element->type|=(ST_MARKER|ST_FACTOR|ST_CONSTANT);
	if(hap_list[0]) {
		if(hap_list[0]->arg.element && hap_list[0]->arg.element!=element)	{
			yyerror1("Haplotype vector (left) used twice");
			hap_list[0]->arg.element=0;
		} else hap_list[0]->arg.element=element;
	}
	if(hap_list[1]) {
		if(hap_list[1]->arg.element && hap_list[1]->arg.element!=element)	{
			yyerror1("Haplotype vector (right) used twice");
			hap_list[1]->arg.element=0;
		} else hap_list[1]->arg.element=element;
	}
	hap_list[0]=hap_list[1]=0;
}

static void set_haplo_element(struct var_element *element,struct var_element *element1)
{
	element->type|=(ST_HAPLO|ST_FACTOR|ST_CONSTANT);
	if(element1) element1->type|=(ST_HAPLO|ST_FACTOR|ST_CONSTANT);
	hap_list[0]=element;
	hap_list[1]=element1;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "do_file_com"
static void do_file_com(char *fname,struct format_clause *fc,struct fformat *ff,struct var_list *vlist)
{
	int i,j;
	struct InFile *file;
	struct format *format;
	struct var_list *vlist1;
	struct var_element *element;
	struct scan_data *sd;
	
	if(!vlist) {
		yyerror1("No variables listed for FILE command\n");
		return;
	} else if(!fname) {
		free_vlist(vlist);
		return;
	} else if(!fname[0]) {
		yyerror1("Zero length filename for FILE command\n");
		free_vlist(vlist);
		return;
	}
	file=Infiles;
	if(!(Infiles=calloc(1,sizeof(struct InFile)))) ABT_FUNC(MMsg);
	Infiles->next=file;
	Infiles->nvar=count_var_list(vlist);
	if(!(Infiles->element=malloc(sizeof(void *)*Infiles->nvar))) ABT_FUNC(MMsg);
	i=0;
	while(vlist) {
		if(vlist->var) {
			sd=vlist->var->data;
			if(sd->vtype&ST_ARRAY) {
				if(vlist->index) {
					element=sd->element+vlist->index-1;
					element->type|=ST_DATA;
					Infiles->element[i++]=element;
				} else {
					for(j=0;j<sd->n_elements;j++) {
						element=sd->element+j;
						element->type|=ST_DATA;
						Infiles->element[i++]=element;
					}
				}
			} else {
				element=sd->element;
				element->type|=ST_DATA;
				Infiles->element[i++]=element;
			}
		} else Infiles->element[i++]=0;
		vlist1=vlist->next;
		free(vlist);
		vlist=vlist1;
	}
	if(fc) {
		format=setup_format(fc);
		Infiles->format=format;
		if(!(scan_error&FORMAT_ERR)) {
			if(format->n_atoms<i) {
				(void)printf("format->n_atoms = %d\n",format->n_atoms);
				(void)printf("i = %d\n",i);
				print_scan_err("Line %d: Error - Too many variables for format clause\n",format->line);
				scan_error|=FORMAT_ERR;
			} else if(format->n_atoms>i)
				  print_scan_warn("Line %d: Warning - Too few variables for format clause\n",format->line);
		}
	} else if(ff) Infiles->fformat=ff;
	Infiles->name=fname;
	Infiles->shell_flag=shell_flag;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "change_type"
static void change_type(int type,struct var_list *vlist)
{
	int j;
	struct scan_data *sd;
	
	
	while(vlist) {
		sd=vlist->var->data;
		if(sd->vtype&ST_ARRAY) {
			if(vlist->index) sd->element[vlist->index-1].type|=type;
			else for(j=0;j<sd->n_elements;j++)
			  sd->element[j].type|=type;
		} else sd->element[0].type|=type;
		vlist=vlist->next;
	}
}

static void free_vlist(struct var_list *vlist)
{
	struct var_list *vlist1;
	
	while(vlist) {
		vlist1=vlist->next;
		free(vlist);
		vlist=vlist1;
	}
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "do_link_com"
static void do_link_com(char *s,int type,struct var_list *vlist)
{
	struct Link *l,*l1;
	struct var_list *vlist1;
	struct var_element *element;
	struct scan_data *sd;
	int i,j;
	
	if(!vlist) ABT_FUNC("Zero var_list pointer\n");
	sd=vlist->var->data;
	if(!(l1=malloc(sizeof(struct Link)))) ABT_FUNC(MMsg);
	l1->next=0;
	l=links;
	if(l) {
		while(l->next) l=l->next;
		l->next=l1;
	} else links=l1;
	if(!s) {
		if(sd->vtype&ST_ARRAY && vlist->index) {
			element=sd->element+vlist->index-1;
			if(element->type&ST_STRING) {
				s=element->arg.string;
				vlist1=vlist->next;
				free(vlist);
				vlist=vlist1;
			}
		} else {
			element=sd->element;
			if(element->type&ST_STRING) {
				s=element->arg.string;
				vlist1=vlist->next;
				free(vlist);
				vlist=vlist1;
			}
		}
	}
	l1->name=s;
	if(!vlist) {
		if(s) print_scan_err("Error: No variable list for LINK command (%s)\n",s);
		else print_scan_err("Error: No variable list for LINK command\n");
		scan_error|=LINK_ERR;
		return;
	}
	i=count_var_list(vlist);
	l1->n_loci=i;
	l1->type=type;
	if(!(l1->element=malloc(sizeof(void *)*i))) ABT_FUNC(MMsg);
	i=0;
	while(vlist) {
		sd=vlist->var->data;
		if(sd->vtype&ST_ARRAY) {
			if(vlist->index) {
				element=sd->element+vlist->index-1;
				if(element->type&ST_LINKED) {
					print_scan_err("Error: %s(%d) appears in multiple linkage groups\n",sd->name,vlist->index);
					scan_error|=LINK_ERR;
				} else element->type|=ST_LINKED;
				l1->element[i++]=element;
			} else {
				if(sd->vtype&ST_LINKED) {
					print_scan_err("Error: %s appears in multiple linkage groups\n",sd->name);
					scan_error|=LINK_ERR;
				} else {
					for(j=0;j<sd->n_elements;j++) {
						element=sd->element+j;
						element->type|=ST_LINKED;
						l1->element[i++]=element;
					}
					sd->vtype|=ST_LINKED;
				}
			}
		} else {
			element=sd->element;
			if(element->type&ST_LINKED) {
				print_scan_err("Error: %s appears in multiple linkage groups\n",sd->name);
				scan_error|=LINK_ERR;
			}
			element->type|=ST_LINKED;
			l1->element[i++]=element;
		}
		vlist1=vlist->next;
		free(vlist);
		vlist=vlist1;
	}
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "do_missing_com"
static void do_missing_com(char *s,struct var_list *vlist,char *s1)
{
	struct var_list *vlist1;
	struct scan_data *sd;
	struct var_element **elem;
	struct Miss *m;
	int i,j;
	char *p;
	
	if(s1) {
		if(vlist) ABT_FUNC("Can't have both explicit and implicit scope\n");
		if(s1[0]==0) {
			print_scan_err("Empty scope - MISSING directive ignored\n");
			free(s1);
			free(s);
			return;
		}
		qstrip(s1);
		p=s1;
		i=j=0;
		while(*p) {
			switch(toupper((int)*p)) {
			 case '!':
			 case 'F':
			 case 'G':
			 case 'P':
			 case 'C':
				break;
			 default: i=1;
			}
			if(i) break;
			p++;
		}
		if(*p) {
			j=1;
			print_scan_err("Illegal character '%c' in MISSING scope\n",*p);
		} else if(*(--p)=='!') {
			j=1;
			print_scan_err("MISSING scope can not end with a '!'\n",*p);
		}
		if(j) {
			free(s1);
			free(s);
			return;
		}
	}
	m=Miss;
	if(!(Miss=malloc(sizeof(struct Miss)))) ABT_FUNC(MMsg);
	Miss->Missing=s;
	Miss->next=m;
	Miss->element=0;
	Miss->scope=0;
	if((i=count_var_list(vlist))) {
		if(!(elem=malloc(sizeof(void *)*i))) ABT_FUNC(MMsg);
		i=0;
		while(vlist) {
			sd=vlist->var->data;
			if(sd->vtype&ST_ARRAY) {
				if(vlist->index) elem[i++]=sd->element+vlist->index-1;
				else for(j=0;j<sd->n_elements;j++) elem[i++]=sd->element+j;
			} else elem[i++]=sd->element;
			Miss->element=elem;
			vlist1=vlist->next;
			free(vlist);
			vlist=vlist1;
		}
	} else if(s1) Miss->scope=s1;
	Miss->nvar=i;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "do_model_com"
static void do_model_com(struct model_list *mlist,struct bin_node *node,struct express *express)
{
	struct model *model,*model1;
	struct var_element *element;
	struct scan_data *sd;
	
	sd=node->data;
	if(!(model=malloc(sizeof(struct model)))) ABT_FUNC(MMsg);
	model->next=0;
   if(Models) {
		model1=Models;
		while(model1->next) model1=model1->next;
		model1->next=model;
	} else Models=model;
	model->trait=sd;
	if(!express) {
		model->index=0;
		sd->element[0].type|=ST_TRAIT;
	} else {
		element=get_element(node,express);
		if(element) {
			model->index=(int)express->arg.value;
			element->index=element->oindex=model->index;
			element->type|=ST_TRAIT;
		} else model->trait=0;
	}
	model->model_list=mlist;
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "add_censored"
static void add_censored(struct var_element *element,const int fg)
{
	struct operation *ops,*ops1,*ops2;
	struct Censor *cen;
	
	if(fg && !element) {
		print_scan_err("Error: Nothing to censor!\n");
		return;
	}
	ops=Op_List;
	/* Reverse list order (really return list to original order! */
	if(ops) {
		ops1=ops->next;
		while(ops1) {
			ops2=ops1->next;
			ops1->next=ops;
			ops=ops1;
			ops1=ops2;
		}
		Op_List->next=0;
		Op_List=ops;
	}
	if(fg) {
		if(!(cen=malloc(sizeof(struct Censor)))) ABT_FUNC(MMsg);
		cen->next=Censored;
		Censored=cen;
		cen->Op_List=ops;
		cen->element=element;
		element->type|=ST_CENSORED;
	} else {
		if(Affected) print_scan_warn("Warning - new affected statement overrules previous statement\n");
		Affected=ops;
	}
	ops=Op_List;
	while(ops) {
		if(ops->type==VARIABLE) ops->arg.element->type|=ST_RESTRICT;
		ops=ops->next;
	}
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "add_restriction"
static void add_restriction(struct var_list *vlist)
{
	struct operation *ops,*ops1,*ops2;
	struct Restrict *res;
	struct var_list *vlist1;
	struct scan_data *sd;
	int i,j;
	
	ops=Op_List;
	/* Reverse list order (really return list to original order! */
	if(ops) {
		ops1=ops->next;
		while(ops1) {
			ops2=ops1->next;
			ops1->next=ops;
			ops=ops1;
			ops1=ops2;
		}
		Op_List->next=0;
		Op_List=ops;
	}
	if(!(res=malloc(sizeof(struct Restrict)))) ABT_FUNC(MMsg);
	res->next=Restrictions;
	Restrictions=res;
	res->Op_List=ops;
	if((res->nvar=count_var_list(vlist))) {
		if(!(res->element=malloc(sizeof(void *)*res->nvar))) ABT_FUNC(MMsg);
		i=0;
		while(vlist) {
			sd=vlist->var->data;
			if(sd->vtype&ST_ARRAY) {
				if(vlist->index) res->element[i++]=sd->element+vlist->index-1;
				else for(j=0;j<sd->n_elements;j++) res->element[i++]=sd->element+j;
			} else res->element[i++]=sd->element;
			vlist1=vlist->next;
			free(vlist);
			vlist=vlist1;
		}	
	} else res->element=0;
	while(ops) {
		if(ops->type==VARIABLE) ops->arg.element->type|=ST_RESTRICT;
		ops=ops->next;
	}
}

static void find_markers(struct bin_node *node,int *i)
{
	int j;
	struct scan_data *sd;
	
	sd=node->data;
	for(j=0;j<sd->n_elements;j++) if(sd->element[j].type&ST_MARKER) {
		markers[*i].element=sd->element+j;
		markers[*i].var=sd;
		markers[(*i)++].index=j+1;
	}
}

static void find_trait_loci(struct bin_node *node,int *i)
{
	int j;
	struct scan_data *sd;
	
	sd=node->data;
	for(j=0;j<sd->n_elements;j++) if(sd->element[j].type&ST_TRAITLOCUS) {
		if(traitlocus) {
			traitlocus[*i].element=sd->element+j;
			traitlocus[*i].var=sd;
			traitlocus[(*i)].index=j+1;
		}
		(*i)++;
	}
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "find_haplo"
static void find_haplo(struct bin_node *node)
{
	int j,k;
	struct scan_data *sd;
	
	sd=node->data;
	for(k=0;k<sd->n_elements;k++) if(sd->element[k].type&ST_HAPLO) {
		for(j=0;j<n_markers;j++) if(sd->element[k].arg.element==markers[j].element) {
			if(!markers[j].hap_element[0]) markers[j].hap_element[0]=sd->element+k;
			else if(!markers[j].hap_element[1])	markers[j].hap_element[1]=sd->element+k;
			else {
				if(markers[j].index) print_scan_err("Error: marker %s(%d) has >2 haplotype vectors associated with it\n",markers[j].var->name,markers[j].index);
				else print_scan_err("Error: marker %s has >2 haplotype vectors associated with it\n",markers[j].var->name);
			}
			break;
		}
		if(j==n_markers) ABT_FUNC("Internal error: can not find marker for haplotype vector\n");
	}
}

#ifdef FUNC_NAME
#undef FUNC_NAME
#endif
#define FUNC_NAME "ReadControl"
int ReadControl(FILE *fptr,char *cname,char **lfile)
{
	int i,j,k;
	void yy_cleanup(void);
	struct InFile *infile,**infile_p;
	struct Restrict *res,*res1,**res_p;
	struct Censor *cen,**cen_p;
	struct var_element *elem;
	struct Link *linkp;
	struct operation *ops;
	
	yyin=fptr;
	fname_list[0]=cname;
	list_ptr=0;
	if(!(f_atom_list=malloc(sizeof(struct format_atom)*f_atom_size))) ABT_FUNC(MMsg);
	for(i=0;i<NUM_SYSTEM_VAR;i++) syst_var[i]=0;
	syst_var[PRUNE_OPTION]=syst_var[RECODE_OPTION]=2;
	syst_var[ERROR_CHECK]=1;
	if((i=yyparse())) print_scan_err("Error: yyparse returned error %d\n",i);
	yy_cleanup();
	/* Sanity check! */
	if(!scan_error_n)	{
		if(!Infiles) print_scan_err("Error: No input files specified\n");
		if(!pedflag) print_scan_err("Error: No pedigree variables specified\n");
		else {
			for(i=0;i<3;i++) if(pedlist[i+family_id]->type&ST_INTTYPE) break;
			if(i<3) for(i=0;i<3;i++) pedlist[i+family_id]->type|=ST_INTTYPE;
		}
		if(root_var) Check_var(root_var);
		/* Flag variables used as the operands to a restriction statement *whose result is used* as ST_REQUIRED */
		res=0;
		while(res!=Restrictions) {	
			res1=Restrictions;
			while(res1->next!=res) res1=res1->next;
			for(i=j=0;i<res1->nvar;i++) if(res1->element[i]->type&ST_REQUIRED) {
				j=1;
				break;
			}
			if(!res1->nvar || j) {
				ops=res1->Op_List;
				while(ops) {
					if(ops->type==VARIABLE) ops->arg.element->type|=ST_REQUIRED;
					ops=ops->next;
				}
			}
			res=res1;
		}
		/* Delete restrict structures that are not used */
		res=Restrictions;
		res_p= &Restrictions;
		while(res) {
			for(i=j=0;i<res->nvar;i++) if(res->element[i]->type&ST_REQUIRED) {
				j=1;
				break;
			}
			if(res->nvar && !j) {
				*res_p=res->next;
				free_restrict(res);
				res= *res_p;
			} else {
				res_p= &res->next;
				res=res->next;
			}
		}
		/* Flag variables used in censored statements as required.  Delete unused censored statements */
		cen=Censored;
		cen_p= &Censored;
		while(cen) {
			if(cen->element->type&ST_TRAIT) {
				ops=cen->Op_List;
				while(ops) {
					if(ops->type==VARIABLE) ops->arg.element->type|=ST_REQUIRED;
					ops=ops->next;
				}
				cen_p= &cen->next;
				cen=cen->next;
			} else {
				*cen_p=cen->next;
				free_op(cen->Op_List);
				free(cen);
				cen= *cen_p;
			}
		}
		if((ops=Affected)) {
			while(ops) {
				if(ops->type==VARIABLE) ops->arg.element->type|=ST_REQUIRED;
				ops=ops->next;
			}
		}
		/* Check file structures - remove ones that aren't needed */
		infile=Infiles;
		infile_p= &Infiles;
		while(infile) {
			infile->ncol=0;
			for(i=0;i<infile->nvar;i++) {
				elem=infile->element[i];
			   if(elem) elem->type&=~ST_FLAG;
			}
			for(i=j=0;i<infile->nvar;i++)	{
				elem=infile->element[i];
				if(elem && elem->type&ST_REQUIRED) {
					if(elem->type&ST_FLAG) {
						print_scan_err("Error: Duplicate variables for file %s\n",infile->name);
						break;
					}
					elem->type|=ST_FLAG;
					if(elem->type&ST_ID)	{
						j|=1;
						infile->id_col=infile->ncol;
					} else if(elem->type&ST_FAMILY) {
						j|=2;
						infile->family_col=infile->ncol;
					}
					infile->ncol++;
				} else infile->element[i]=0;
			}
			for(i=0;i<infile->nvar;i++) if(infile->element[i]) infile->element[i]->type&=~ST_FLAG;
			if(!(j&1)) print_scan_err("Error: No id column for file %s\n",infile->name);
			else if(family_id && j!=3) print_scan_err("Error: No family column for file %s\n",infile->name);
			if(infile->ncol==1) {
				*infile_p=infile->next;
				free_infile(infile);
				infile= *infile_p;
			} else {
				infile_p= &infile->next;
				infile=infile->next;
			}
		}
		if(!Infiles) print_scan_err("Error: No input files with data\n");
		free(f_atom_list);
		/* Count markers and link up with haplotype vectors */
		if(n_markers) {
			if(!(markers=calloc((size_t)n_markers,sizeof(struct Marker)))) ABT_FUNC(MMsg);
			for(i=0;i<n_markers;i++) {
				markers[i].allele_trans=0;
			   markers[i].order=0;
				markers[i].o_size=0;
			}
			i=0;
			if(root_var) {
				check_vars(root_var,&i,find_markers);
				check_vars_1(root_var,find_haplo);
			}
			for(i=0;i<n_markers;i++) {
				linkp=links;
				j=0;
				while(linkp) {
					j++;
					for(k=0;k<linkp->n_loci;k++) {
						if(linkp->element[k]==markers[i].element) {
							markers[i].link=j;
							break;
						}
					}
					if(k<linkp->n_loci) break;
					linkp=linkp->next;
				}
				if(!linkp) {
					if(markers[i].var->vtype&ST_ARRAY)
					  abt(__FILE__,__LINE__,"%s(): No linkage group specified for candidate gene %s(%d)\n",FUNC_NAME,markers[i].var->name,markers[i].index);
					else abt(__FILE__,__LINE__,"%s(): No linkage group specified for candidate gene %s\n",FUNC_NAME,markers[i].var->name);
				}
				if(markers[i].hap_element[0]) {
					if(markers[i].element->type&ST_DATA) {
						if(markers[i].var->vtype&ST_ARRAY)
						  print_scan_err("Error: marker variable %s(%d) can not have both genotype and haplotype data\n",markers[i].var->name,markers[i].index);
						else
						  print_scan_err("Error: marker variable %s can not have both genotype and haplotype data\n",markers[i].var->name);
					}
					if(markers[i].hap_element[0]->type&ST_INTTYPE) markers[i].hap_element[1]->type|=ST_INTTYPE;
					if(markers[i].hap_element[1] && markers[i].hap_element[1]->type&ST_INTTYPE) markers[i].hap_element[0]->type|=ST_INTTYPE;
				} else {
					if(!(markers[i].element->type&ST_DATA)) {
						if(markers[i].var->vtype&ST_ARRAY)
						  print_scan_err("Error: marker variable %s(%d) has no data\n",markers[i].var->name,markers[i].index);
						else
						  print_scan_err("Error: marker variable %s has no data\n",markers[i].var->name);
					}
				}
			}
		}
		i=0;
		if(root_var) check_vars(root_var,&i,find_trait_loci);
		if(i) {
			if(i>1) print_scan_err("Error: multiple trait loci indicated\n");
			else {
				if(!(traitlocus=calloc(1,sizeof(struct Marker)))) ABT_FUNC(MMsg);
				traitlocus->order=0;
				traitlocus->o_size=0;
				i=0;
				check_vars(root_var,&i,find_trait_loci);
			}
		}
		if(Models && Models->next && !syst_var[MULTIVARIATE_TEST]) {
			print_scan_err("Error: Multiple models not currently supported\n");
		}
	}
	*lfile=LogFile;
	if(!scan_error_n && !Miss && !syst_var[NO_DEFAULT_MISSING]) {
		do_missing_com(strdup("0"),0,strdup("PF"));
	}
	return scan_error_n;
}
